/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

static int getStrNext();

/* ١եξեɤ߹ */
int getBaseConfig( base )
BASEINFO	*base ;
{
	FILE	*fp ;
	char	baseName[1024] ;
	char	cbuff[1024] ;
	char	workbuff[1024] ;
	char	*ptr ;
	int	n ;

	if ( (fp = fopen( (char *)getPath(CXPSYSTEM_BASE), "r" )) == NULL )
		return(-1);
	memset( cbuff, 0x00, sizeof(cbuff) );
	while( fgets( cbuff, sizeof(cbuff), fp) != 0)
	{
		if (( cbuff[0] == '#'  ) ||  ( cbuff[0] == '\n' )
		||  ( cbuff[0] == '\t' ) ||  ( cbuff[0] == ' '  ))
			continue ;

	getStrNext( cbuff,"CXPLORER=",strlen("CXPLORER="),&base->cxplorer);
	getStrNext( cbuff,"CXPNOTE=", strlen("CXPNOTE="), &base->cxpnote);
	getStrNext( cbuff,"CXPADDR=", strlen("CXPADDR="), &base->cxpaddr);
	getStrNext( cbuff,"CXPCALEN=",strlen("CXPCALEN="),&base->cxpcalen);
	getStrNext( cbuff,"CXPMAIL=", strlen("CXPMAIL="), &base->cxpmail);
	getStrNext( cbuff,"CXPIMAGE=",strlen("CXPIMAGE="),&base->cxpimage);
	getStrNext( cbuff,"CXPBACKUP=",strlen("CXPBACKUP="),&base->cxpbackup);
	getStrNext( cbuff,"CXPRESTORE=",strlen("CXPRESTORE="),&base->cxprestore);
	getStrNext( cbuff,"CXPDEVICE=",strlen("CXPDEVICE="),&base->cxpdevice);
	getStrNext( cbuff,"TOPCMD01=",strlen("TOPCMD01="),&base->topcmd[0]);
	getStrNext( cbuff,"TOPCMD02=",strlen("TOPCMD02="),&base->topcmd[1]);
	getStrNext( cbuff,"TOPCMD03=",strlen("TOPCMD03="),&base->topcmd[2]);
	getStrNext( cbuff,"TOPCMD04=",strlen("TOPCMD04="),&base->topcmd[3]);
	getStrNext( cbuff,"TOPCMD05=",strlen("TOPCMD05="),&base->topcmd[4]);
	getStrNext( cbuff,"TOPCMD06=",strlen("TOPCMD06="),&base->topcmd[5]);
	getStrNext( cbuff,"TOPCMD07=",strlen("TOPCMD07="),&base->topcmd[6]);
	getStrNext( cbuff,"TOPCMD08=",strlen("TOPCMD08="),&base->topcmd[7]);
	getStrNext( cbuff,"TOPCMD09=",strlen("TOPCMD09="),&base->topcmd[8]);
	getStrNext( cbuff,"NOTE01=",  strlen("NOTE01="),  &base->note[0]);
	getStrNext( cbuff,"NOTE02=",  strlen("NOTE02="),  &base->note[1]);
	getStrNext( cbuff,"NOTE03=",  strlen("NOTE03="),  &base->note[2]);
	getStrNext( cbuff,"NOTE04=",  strlen("NOTE04="),  &base->note[3]);
	getStrNext( cbuff,"MAIL01=",  strlen("MAIL01="),  &base->mail[0]);
	getStrNext( cbuff,"MAIL02=",  strlen("MAIL02="),  &base->mail[1]);
	getStrNext( cbuff,"MAIL03=",  strlen("MAIL03="),  &base->mail[2]);
	getStrNext( cbuff,"MAIL04=",  strlen("MAIL04="),  &base->mail[3]);
	getStrNext( cbuff,"MAIL05=",  strlen("MAIL05="),  &base->mail[4]);
	getStrNext( cbuff,"MAIL06=",  strlen("MAIL06="),  &base->mail[5]);
	getStrNext( cbuff,"MAIL07=",  strlen("MAIL07="),  &base->mail[6]);
	getStrNext( cbuff,"MAIL08=",  strlen("MAIL08="),  &base->mail[7]);
	getStrNext( cbuff,"MAIL09=",  strlen("MAIL09="),  &base->mail[8]);
	getStrNext( cbuff,"MAILT01=", strlen("MAILT01="), &base->mailt[0]);
	getStrNext( cbuff,"MAILT02=", strlen("MAILT02="), &base->mailt[1]);
	getStrNext( cbuff,"SELECT_ON=", strlen("SELECT_ON="), &base->selecton);
	getStrNext( cbuff,"SELECT_SUB=", strlen("SELECT_SUB="), &base->selectsub);
	getStrNext( cbuff,"SELECT_OFF=", strlen("SELECT_OFF="), &base->selectoff);
	getStrNext( cbuff,"DEVICE_FDD=", strlen("DEVICE_FDD="), &base->devicefdd);
	getStrNext( cbuff,"DEVICE_TAPE=", strlen("DEVICE_TAPE="), &base->devicetape);
	getStrNext( cbuff,"DEVICE_CD=", strlen("DEVICE_CD="), &base->devicecd);
	getStrNext( cbuff,"DEVICE_UNKNOWN=", strlen("DEVICE_UNKNOWN="), &base->deviceunknown);
	getStrNext( cbuff,"KIND_MINE_NAME=", strlen("KIND_MINE_NAME="), &base->kindmine.name);
	getStrNext( cbuff,"KIND_WORK_NAME=", strlen("KIND_WORK_NAME="), &base->kindwork.name);
	getStrNext( cbuff,"KIND_TASTE_NAME=", strlen("KIND_TASTE_NAME="), &base->kindtaste.name);
	getStrNext( cbuff,"KIND_PLAY_NAME=", strlen("KIND_PLAY_NAME="), &base->kindplay.name);
	getStrNext( cbuff,"KIND_OTHER_NAME=", strlen("KIND_OTHER_NAME="), &base->kindother.name);
	getStrNext( cbuff,"KIND_MINE_NEXT=", strlen("KIND_MINE_NEXT="), &base->kindmine.next);
	getStrNext( cbuff,"KIND_WORK_NEXT=", strlen("KIND_WORK_NEXT="), &base->kindwork.next);
	getStrNext( cbuff,"KIND_TASTE_NEXT=", strlen("KIND_TASTE_NEXT="), &base->kindtaste.next);
	getStrNext( cbuff,"KIND_PLAY_NEXT=", strlen("KIND_PLAY_NEXT="), &base->kindplay.next);
	getStrNext( cbuff,"KIND_OTHER_NEXT=", strlen("KIND_OTHER_NEXT="), &base->kindother.next);
	getStrNext( cbuff,"KIND_COMM_NEXT=", strlen("KIND_COMM_NEXT="), &base->kindcomm.next);
	getStrNext( cbuff,"KIND_MINE_NONE=", strlen("KIND_MINE_NONE="), &base->kindmine.none);
	getStrNext( cbuff,"KIND_WORK_NONE=", strlen("KIND_WORK_NONE="), &base->kindwork.none);
	getStrNext( cbuff,"KIND_TASTE_NONE=", strlen("KIND_TASTE_NONE="), &base->kindtaste.none);
	getStrNext( cbuff,"KIND_PLAY_NONE=", strlen("KIND_PLAY_NONE="), &base->kindplay.none);
	getStrNext( cbuff,"KIND_OTHER_NONE=", strlen("KIND_OTHER_NONE="), &base->kindother.none);
	getStrNext( cbuff,"KIND_COMM_NONE=", strlen("KIND_COMM_NONE="), &base->kindcomm.none);
	getStrNext( cbuff,"LEVEL_NORMAL_NAME=", strlen("LEVEL_NORMAL_NAME="), &base->levelnormal.name);
	getStrNext( cbuff,"LEVEL_JYUYOU_NAME=", strlen("LEVEL_JYUYOU_NAME="), &base->leveljyuyou.name);
	getStrNext( cbuff,"LEVEL_KINKYU_NAME=", strlen("LEVEL_KINKYU_NAME="), &base->levelkinkyu.name);
	getStrNext( cbuff,"LEVEL_OTHER_NAME=", strlen("LEVEL_OTHER_NAME="), &base->levelother.name);
	getStrNext( cbuff,"LEVEL_NORMAL_NONE=", strlen("LEVEL_NORMAL_NONE="), &base->levelnormal.none);
	getStrNext( cbuff,"LEVEL_JYUYOU_NONE=", strlen("LEVEL_JYUYOU_NONE="), &base->leveljyuyou.none);
	getStrNext( cbuff,"LEVEL_KINKYU_NONE=", strlen("LEVEL_KINKYU_NONE="), &base->levelkinkyu.none);
	getStrNext( cbuff,"LEVEL_OTHER_NONE=", strlen("LEVEL_OTHER_NONE="), &base->levelother.none);
	getStrNext( cbuff,"LEVEL_NORMAL_ALARM=", strlen("LEVEL_NORMAL_ALARM="), &base->levelnormal.next);
	getStrNext( cbuff,"LEVEL_JYUYOU_ALARM=", strlen("LEVEL_JYUYOU_ALARM="), &base->leveljyuyou.next);
	getStrNext( cbuff,"LEVEL_KINKYU_ALARM=", strlen("LEVEL_KINKYU_ALARM="), &base->levelkinkyu.next);
	getStrNext( cbuff,"LEVEL_OTHER_ALARM=", strlen("LEVEL_OTHER_ALARM="), &base->levelother.next);

	}
	fclose( fp );

	if ( base->cxplorer == NULL
	||   base->cxpnote == NULL
	||   base->cxpmail == NULL
	||   base->cxpimage == NULL
	||   base->cxpbackup == NULL
	||   base->cxprestore == NULL
	||   base->cxpdevice == NULL
	||   base->topcmd[0] == NULL
	||   base->topcmd[1] == NULL
	||   base->topcmd[2] == NULL
	||   base->topcmd[3] == NULL
	||   base->topcmd[4] == NULL
	||   base->topcmd[5] == NULL
	||   base->topcmd[6] == NULL
	||   base->topcmd[7] == NULL
	||   base->topcmd[8] == NULL
	||   base->note[0] == NULL
	||   base->note[1] == NULL
	||   base->note[2] == NULL
	||   base->note[3] == NULL
	||   base->mail[0] == NULL
	||   base->mail[1] == NULL
	||   base->mail[2] == NULL
	||   base->mail[3] == NULL
	||   base->mail[4] == NULL
	||   base->mail[5] == NULL
	||   base->mail[6] == NULL
	||   base->mail[7] == NULL
	||   base->mail[8] == NULL
	||   base->mailt[0] == NULL
	||   base->mailt[1] == NULL
	||   base->selecton == NULL
	||   base->selectoff == NULL
	||   base->kindmine.name == NULL
	||   base->kindmine.next == NULL
	||   base->kindmine.none == NULL
	||   base->kindwork.name == NULL
	||   base->kindwork.next == NULL
	||   base->kindwork.none == NULL
	||   base->kindtaste.name == NULL
	||   base->kindtaste.next == NULL
	||   base->kindtaste.none == NULL
	||   base->kindplay.name == NULL
	||   base->kindplay.next == NULL
	||   base->kindplay.none == NULL
	||   base->kindother.name == NULL
	||   base->kindother.next == NULL
	||   base->kindother.none == NULL
	||   base->kindcomm.next == NULL
	||   base->levelnormal.name == NULL
	||   base->levelnormal.next == NULL
	||   base->levelnormal.none == NULL
	||   base->leveljyuyou.name == NULL
	||   base->leveljyuyou.next == NULL
	||   base->leveljyuyou.none == NULL
	||   base->levelkinkyu.name == NULL
	||   base->levelkinkyu.next == NULL
	||   base->levelkinkyu.none == NULL
	||   base->levelother.name == NULL
	||   base->levelother.next == NULL
	||   base->levelother.none == NULL )
	{
		return(-1);
	}

	return(0);
}

static int getStrNext( char *buff, char *data, int size, char **set )
{
    char workbuff[1024] ;
    char *ptr ;

    if ( !strncmp( buff, data, size ) )
    {
	memset( workbuff, 0x00, sizeof(workbuff) );
	strncpy( workbuff, buff, strlen(buff) );
	ptr = nstrchr ( workbuff, '"', 2 );
	*ptr = 0x00 ;
	ptr = nstrchr ( workbuff, '"', 1 );
	(*set) = (char *)g_strdup( (char *)getPath(ptr+1) );
    }
}
