/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"

int getImageDirectory( char *pathinfo[256] )
{
    DIR     *dfd;
    struct dirent *dp ;
    char    pathname[256] ;
    int     i ;
    int     kensu ;
    struct stat fileinfo ;

    /*-- ǥ쥯ȥΥץ --*/
    if ( (dfd = opendir("/")) == NULL )
	return(0);

    /*-- ǥ쥯ȥɤ߹ --*/
    kensu = 0 ;
    for(i=0; (dp = readdir(dfd)) != NULL; i++)
    {
	/* ̵뤹ե */
	if ( !strcmp( dp->d_name, "." )
	||   !strcmp( dp->d_name, "..")
	||   (*(dp->d_name) == '.')
	||   !strcmp( dp->d_name, "dev")
	||   !strcmp( dp->d_name, "devices")
	||   !strcmp( dp->d_name, "proc")
	||   !strcmp( dp->d_name, "etc")
	||   !strcmp( dp->d_name, "bin")
	||   !strcmp( dp->d_name, "sbin")
	||   !strcmp( dp->d_name, "platform")
	||   !strcmp( dp->d_name, "lib")
	||   !strcmp( dp->d_name, "var")
	||   !strcmp( dp->d_name, "xfn")
	||   !strcmp( dp->d_name, "kernel")
	||   !strcmp( dp->d_name, "boot")
	||   !strcmp( dp->d_name, "sbin")
	||   !strcmp( dp->d_name, "lost+found"))
	    continue ;

	sprintf( pathname,"/%s", dp->d_name );
	stat( pathname, &fileinfo );

	/* ǥ쥯ȥǤʤϽʤ */
	if ( !S_ISDIR( fileinfo.st_mode ) )
	    continue ;

	pathinfo[kensu] = strdup(pathname);
	kensu++;
    }

    /*-- ǥ쥯ȥΥ --*/
    closedir(dfd);

    return(kensu);
}
