/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

/* եȾեɤ߹ */
int getFontConfig( font )
FONTINFO	*font ;
{
	FILE	*fp ;
	char	baseName[1024] ;
	char	cbuff[1024] ;
	char	workbuff[1024] ;
	char	*ptr ;
	int	ix ;

	if ( (fp = fopen( (char *)getPath(CXPSYSTEM_FONT), "r" )) == NULL )
		return(-1);

	ix = 0 ;
	font->kensu = 0 ;
	memset( cbuff, 0x00, sizeof(cbuff) );
	while( fgets( cbuff, sizeof(cbuff), fp) != 0)
	{
		if (( cbuff[0] == '#'  ) ||  ( cbuff[0] == '\n' )
		||  ( cbuff[0] == '\t' ) ||  ( cbuff[0] == ' '  ))
			continue ;

		if ( strmatch( "FONT_TITLE*=*", cbuff ) == 0 )
		{
		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '=', 1 );
		    *ptr = 0x00 ;
		    ix = atoi( &workbuff[10] );

		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    font->font[ix-1].title = g_strdup( ptr+1 );

		    if ( ix >= font->kensu )
			font->kensu = ix ;
	        }
		if ( strmatch( "FONT_ALPHA*=*", cbuff ) == 0 )
		{
		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '=', 1 );
		    *ptr = 0x00 ;
		    ix = atoi( &workbuff[10] );

		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    font->font[ix-1].font_alpha = g_strdup( ptr+1 );
	        }
		if ( strmatch( "FONT_KANJI*=*", cbuff ) == 0 )
		{
		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '=', 1 );
		    *ptr = 0x00 ;
		    ix = atoi( &workbuff[10] );

		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    font->font[ix-1].font_kanji = g_strdup( ptr+1 );
	        }
		if ( strmatch( "FONT_RKANA*=*", cbuff ) == 0 )
		{
		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '=', 1 );
		    *ptr = 0x00 ;
		    ix = atoi( &workbuff[10] );

		    memcpy( workbuff, cbuff, sizeof(cbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    font->font[ix-1].font_kana = g_strdup( ptr+1 );
	        }
	}
	fclose( fp );

	return(0);
}
