/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"

char *getSize( int size )
{
    static char sizename[256] ;

    if ( size >= 1000 * 1000 * 1000 )
    {
	sprintf( sizename, "%d,%3.03d,%3.03d,%3.03d",
			(size/(1000*1000*1000))%1000,
			(size/(1000*1000))%1000,
			(size/(1000)%1000),
			(size%1000)  ) ;
    }else
    if ( size >= 1000 * 1000 )
    {
	sprintf( sizename, "%d,%3.03d,%3.03d",
			(size/(1000*1000))%1000,
			(size/(1000))%1000,
			(size%1000)  ) ;
    }else
    if ( size >= 1000 )
    {
	sprintf( sizename, "%d,%03.3d",
			(size/(1000)),
			(size%1000)  ) ;
    }else
    {
	sprintf( sizename, "%d", size );
    }

    return( sizename );
}
