/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

CxpAddr    *cxpaddr;

void cxpaddr_init()
{
  GtkWidget	*hpaned;
  GtkWidget	*vbox;
  GtkWidget	*subitem ;
  int		row ;

  /* ưɣĤμ */
  cxpaddr->uid = getuid();
  cxpaddr->gid = getgid();

  /* ١ɤ߹ */
  getBaseConfig( &cxpaddr->base ) ;

  /* ɥ쥹ɤ߹ */
  getAddressData( &(cxpaddr->addr_kensu), &(cxpaddr->addr) );

  /* ν */
  cxpaddr->selectrow = -1 ;

  /* ١Υɥ */
  cxpaddr->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect(GTK_OBJECT(cxpaddr->window), "destroy",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_window_set_title(GTK_WINDOW(cxpaddr->window), "Cxpaddr" );
  gtk_widget_set_usize(cxpaddr->window, 100, 100);
  gtk_window_set_default_size(GTK_WINDOW(cxpaddr->window),550,300);

  /* ɥɽ */
  gtk_widget_show(cxpaddr->window);


  /* VBOX */
  cxpaddr->vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(cxpaddr->window), cxpaddr->vbox);
  gtk_widget_show(cxpaddr->vbox);


  /* ˥塼 */
  cxpaddr_menu_init() ;

  /* ꥹȤ */
  cxpaddr_list_init() ;

  /* ǡɽ */
  cxpaddr_dataview();

  return;
}

int main(int argc, char *argv[])
{
	int	i ;

	CxpBasePathInit() ;

	/* ޥ͡㵯ư */
	cxp_manager_start();

	cxpaddr = (CxpAddr *)g_malloc(sizeof(CxpAddr));

	gtk_set_locale();
	gtk_init(&argc, &argv);
  
	cxpaddr_init();

	gtk_main();
	exit(0);
}
