/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpbackup.h"

extern	CxpBackup    *cxpbackup;

extern char *getdataJVersion() ;
extern char *getdataJEmail() ;
extern char *getdataUrl() ;
extern char *getdataCopyright() ;

static void helpdialog_destroy(GtkWidget *widget, gpointer data)
{
  /* ɥϥɤ */
  gtk_grab_remove ( widget );
  gtk_widget_hide( widget );
}

int cxpbackuphelpfunc_help ()
{
  GtkWidget *dialog ;
  GtkWidget *label[5] ;
  GtkWidget *button ;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap ;
  GdkBitmap *mask;
  GtkStyle  *style;
  int x,y,w,h ;

  w = gdk_screen_width();
  h = gdk_screen_height();
  x = w * 0.5;
  y = h * 0.5;

  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), "CxpbackupˤĤ");
  gtk_widget_set_usize(dialog, 300, 210);
  gtk_widget_set_uposition(dialog, (x - 300*0.5), (y - 210*0.5));
  gtk_grab_add (dialog);
  gtk_widget_show (dialog);

  label[4] = gtk_label_new( getdataCopyright() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[4], FALSE, TRUE, 5);
  gtk_widget_show (label[4]);

  label[3] = gtk_label_new( getdataJEmail());
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[3], FALSE, TRUE, 5);
  gtk_widget_show (label[3]);

  label[2] = gtk_label_new( getdataUrl() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[2], FALSE, TRUE, 5);
  gtk_widget_show (label[2]);

  label[1] = gtk_label_new( getdataJVersion() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[1], FALSE, TRUE, 5);
  gtk_widget_show (label[1]);

  style = gtk_widget_get_style( cxpbackup->window );
  pixmap = gdk_pixmap_create_from_xpm(
                cxpbackup->window->window,
                &mask, &style->bg[GTK_STATE_NORMAL],
                cxpbackup->base.cxpbackup );
  pixmapwid = gtk_pixmap_new (pixmap, mask);
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		pixmapwid, TRUE, TRUE, 0);
  gtk_widget_show (pixmapwid);


  button = gtk_button_new_with_label ("Ĥ");
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			(GtkSignalFunc) helpdialog_destroy,
			GTK_OBJECT (dialog));

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		button, FALSE, TRUE, 0);
  gtk_widget_show (button);

  return(0);
}
