/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpbackup.h"

extern CxpBackup *cxpbackup ;

/*
 * CxpBackup Version Header
 *
 * version  date        log
 *  1.0.0   2000/08/01  first released.
 *  1.0.1   2000/08/07  device selection bug fix.
 *
 *
 */

static char CxpBackupTitle[] =
"CxpBackup Version 1.0.1 Aug./07/2000 (C)K.Hatakeda" ;

static char *BackupVersion = "CxpBackup Ver 1.0.1 2000/08/07" ;
static char *Version     = "С 1.0.1 2000/08/07" ;
static char *Website     = "http://www1.sphere.ne.jp/hatakeda" ;
static char *Email       = "Mail: hatakeda@mbm.sphere.ne.jp" ;
static char *EmailJ      = "Ϣ衧 hatakeda@mbm.sphere.ne.jp" ;
static char *Copyright   = "Copyright 1998-2000 Konta" ;

char *getdataTitle()
{
        return(CxpBackupTitle);
}
char *getdataVersion()
{
        return(BackupVersion);
}
char *getdataJVersion()
{
        return(Version);
}
char *getdataEmail()
{
        return(Email);
}
char *getdataJEmail()
{
        return(EmailJ);
}
char *getdataUrl()
{
        return(Website);
}
char *getdataCopyright()
{
	return(Copyright);
}
