/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpcalc.h"

CxpCalc *cxpcalc ;

/*
 * Cxpcalc Version Header
 *
 * version  date        log
 *  1.0.0   2000/03/15  first released.
 *  1.0.1   2000/04/17  main exit code is ZERO add.
 *  1.0.2   2000/08/01  cxpmanager start add.
 *
 */

static char *Version   = "С 1.0.2 2000/08/01" ;
static char *Website   = "http://www1.sphere.ne.jp/hatakeda" ;
static char *Email     = "Ϣ衧 hatakeda@mbm.sphere.ne.jp" ;
static char *Copyright = "Copyright 1998-2000 Konta" ;


static int cxpcalc_init()
{
    getBaseConfig( &cxpcalc->base ) ;

    cxpcalc->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_signal_connect(GTK_OBJECT(cxpcalc->window), "destroy",
				GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
    gtk_window_set_title(GTK_WINDOW(cxpcalc->window), "Cxp Calc" );
    gtk_widget_set_usize(cxpcalc->window, 100, 100);
    gtk_window_set_default_size(GTK_WINDOW(cxpcalc->window),250,200);
    gtk_widget_show(cxpcalc->window);

    cxpcalc->vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(cxpcalc->window), cxpcalc->vbox);
    gtk_widget_show(cxpcalc->vbox);

    cxpcalc->kekka = 0.0 ;
    cxpcalc->val1  = 0.0 ;
    cxpcalc->val2  = 0.0 ;
    cxpcalc->mode  = 0 ; /* DEC */
    cxpcalc->iset = 0 ;
    cxpcalc->icount1 = 0 ;
    cxpcalc->icount2 = 0 ;
    memset( cxpcalc->buffer1, 0x00, sizeof(cxpcalc->buffer1) );
    memset( cxpcalc->buffer2, 0x00, sizeof(cxpcalc->buffer2) );
    memset( cxpcalc->viewdata, 0x00, sizeof(cxpcalc->viewdata) );
    sprintf( cxpcalc->viewdata, "0" );

    create_calc_view();

    create_calc_btn();
}

main( int argc, char *argv[] )
{
    CxpBasePathInit();

    /* ޥ͡㵯ư */
    cxp_manager_start();

    cxpcalc = (CxpCalc *)g_malloc(sizeof(CxpCalc));

    gtk_set_locale();
    gtk_init (&argc, &argv);

    cxpcalc_init();

    gtk_main();
    exit(0) ;
}
