/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpdevice.h"

extern CxpDevice    *cxpdevice;

static GtkWidget	*filew;

static int deviceselection( GtkWidget *widget, GtkFileSelection *fs)
{
    char devname[1024] ;

    gtk_entry_set_text(GTK_ENTRY(cxpdevice->deviceEntry),
	gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
    
    gtk_widget_hide(filew);
 
    return(0) ;
}

int selectBtnFunc(GtkWidget *widget, gpointer data)
{
    filew = gtk_file_selection_new ( "ǥХ" );
    
    gtk_signal_connect (
	GTK_OBJECT (filew), "destroy",
	(GtkSignalFunc)gtk_widget_destroy,
	GTK_OBJECT(filew));

    gtk_signal_connect (
	GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),   
	"clicked", (GtkSignalFunc)deviceselection, filew );

    gtk_signal_connect_object (
	GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
	"clicked", (GtkSignalFunc)gtk_widget_destroy,
	GTK_OBJECT (filew));
        
    gtk_widget_show(filew);

}
