/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern	CxpMgr    *cxpmgr;

#ifdef	CXP_ENGLISH
#define	ADDRESS_LABEL	"Address:"
#else
#define	ADDRESS_LABEL	"ɥ쥹"
#endif

static void address_callback( widget,  entry)
GtkWidget	*widget ;
GtkWidget	*entry ;
{
	FINFO	*finfo ;
	int	row ;
	char	*entry_text;
	char	*ptr ;
	char	workbuff[1024] ;
	struct stat fileinfo ;

	entry_text = gtk_entry_get_text(GTK_ENTRY(entry));

	/* ɽ */
	CxpDirView( entry_text );
}

void cxp_address_init()
{
  GtkWidget	*handle_box ;
  GtkWidget	*hbox ;
  GtkWidget	*label ;
  GtkWidget	*subitem ;

  handle_box = gtk_handle_box_new ();
  gtk_box_pack_start (GTK_BOX(cxpmgr->vbox), handle_box, FALSE, FALSE, 0 );
  gtk_widget_show (handle_box);

  hbox = gtk_hbox_new(FALSE, 2);
  gtk_container_add ( GTK_CONTAINER ( handle_box ) , hbox );
/***
  gtk_box_pack_start(GTK_BOX(handle_box), hbox, FALSE, FALSE, 2 );
***/
  gtk_widget_show(hbox);

  label = gtk_label_new(ADDRESS_LABEL);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 5 );
  gtk_widget_show(label);

  cxpmgr->address = gtk_entry_new_with_max_length( 1024 );
  gtk_signal_connect(GTK_OBJECT(cxpmgr->address), "activate",
			GTK_SIGNAL_FUNC(address_callback),
			cxpmgr->address);

  gtk_box_pack_start(GTK_BOX(hbox), cxpmgr->address, TRUE, TRUE, 5 );
  gtk_widget_show(cxpmgr->address);


  gtk_entry_set_text( GTK_ENTRY(cxpmgr->address), cxpmgr->pwdbuff );


}
