/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpmail.h"

extern	CxpMail    *cxpmail;

/* ᡼ξư */
static int _movemail( int sBoxId, int dBoxId, int number )
{
    int count ;

    /* ¾ξϺȢذư */
    count = cxpmail->minfo.box[dBoxId]->count ;

    cxpmail->minfo.box[dBoxId]->mail[count] =
		malloc(sizeof(MailInfo) );
    if ( cxpmail->minfo.box[dBoxId]->mail[count] == (MailInfo *)NULL )
    {
	return(-1);
    }

    memset(cxpmail->minfo.box[dBoxId]->mail[count],0x00,sizeof(MailInfo));
    cxpmail->minfo.box[dBoxId]->mail[count]->no =
		cxpmail->minfo.box[sBoxId]->mail[number]->no ;
    cxpmail->minfo.box[dBoxId]->mail[count]->name =
		g_strdup(cxpmail->minfo.box[sBoxId]->mail[number]->name) ;
    cxpmail->minfo.box[dBoxId]->mail[count]->sendName =
		g_strdup(cxpmail->minfo.box[sBoxId]->mail[number]->sendName) ;
    cxpmail->minfo.box[dBoxId]->mail[count]->ccName =
		g_strdup(cxpmail->minfo.box[sBoxId]->mail[number]->ccName) ;
    cxpmail->minfo.box[dBoxId]->mail[count]->title =
		g_strdup(cxpmail->minfo.box[sBoxId]->mail[number]->title) ;
    cxpmail->minfo.box[dBoxId]->mail[count]->size =
		cxpmail->minfo.box[sBoxId]->mail[number]->size ;
    cxpmail->minfo.box[dBoxId]->mail[count]->date =
		cxpmail->minfo.box[sBoxId]->mail[number]->date ;

    if ( cxpmail->minfo.box[sBoxId]->mail[number]->size > 0 )
    {
	getMailData( cxpmail->minfo.box[sBoxId],
		&cxpmail->minfo.box[sBoxId]->mail[number] );

	if ( cxpmail->minfo.box[sBoxId]->mail[number]->data != NULL )
	{
	    cxpmail->minfo.box[dBoxId]->mail[count]->data =
		malloc(cxpmail->minfo.box[sBoxId]->mail[number]->size);
	    if ( cxpmail->minfo.box[dBoxId]->mail[count]->data == (char *)NULL )
	    {
		create_messageWin(cxpmail->window, "ȢذưǤޤǤ");
		free( cxpmail->minfo.box[dBoxId]->mail[count] );
	    }
	    memcpy(cxpmail->minfo.box[dBoxId]->mail[count]->data,
		cxpmail->minfo.box[sBoxId]->mail[number]->data,
		cxpmail->minfo.box[sBoxId]->mail[number]->size );
	}
    }else{
	cxpmail->minfo.box[dBoxId]->mail[count]->data = (char *)NULL;
    }

    /* Ȣη򹹿 */
    cxpmail->minfo.box[dBoxId]->count = count + 1;

    /* ȢΥإå򹹿 */
    setMailHeader( dBoxId );

    /* ȢΥǡ򹹿 */
    setMailData(  cxpmail->minfo.box[dBoxId],
	 cxpmail->minfo.box[dBoxId]->mail[count] );

    /* ΥܥåΥǡ */
    delMailData( cxpmail->minfo.box[sBoxId],
	 cxpmail->minfo.box[sBoxId]->mail[number] );

    /* ΥܥåΥإå */
    cxpmail->minfo.box[sBoxId]->mail[number]->no = 0 ;
    setMailHeader( sBoxId );


    return(0);
}

int cxpmail_movemail( int sBoxId, int dBoxId, int number )
{
    int status ;

    status = _movemail( sBoxId, dBoxId, number );

    return(status);
}

int cxpmail_movemail_withview( int sBoxId, int dBoxId, int number )
{
    int status ;

    status = _movemail( sBoxId, dBoxId, number );
    if ( status < 0 )
	return(-1);

    /* ɤ߹ */
    getMailHeader(cxpmail->minfo.box[sBoxId]);
    getMailHeader(cxpmail->minfo.box[dBoxId]);

    /* ̤򹹿 */
    cxpmail_base_view();
    cxpmail_title_view();
    cxpmail_view_view();

    /* ΰ֤᤹ */
    if ( cxpmail->minfo.box[sBoxId]->count > (number+1) )
    {
	gtk_clist_select_row( GTK_CLIST(cxpmail->list_title), number, 0 );
	gtk_clist_moveto( GTK_CLIST(cxpmail->list_title),
		number , 0, (gfloat)0.5, (gfloat)0.0 );
    }


    return(0);
}
