/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpmail.h"

extern CxpMail *cxpmail ;

static int listbuttonpress()
{
}

int cxpmail_view_init()
{
    GtkWidget *table ;
    GtkWidget *vscrollbar ;
    GtkWidget *hbox;

    table = gtk_table_new (2, 2, FALSE);
    gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
    gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
#if 0
    gtk_box_pack_start (GTK_BOX (cxpmail->vbox), table, TRUE, TRUE, 5);
#else
    gtk_paned_add2(GTK_PANED(cxpmail->vpanel), table);
#endif
    gtk_widget_show (table);

    /* GtkText åȤ */
    cxpmail->list_view = gtk_text_new (NULL, NULL);
    gtk_text_set_editable (GTK_TEXT (cxpmail->list_view), FALSE);
    gtk_table_attach (GTK_TABLE (table), cxpmail->list_view, 0, 1, 0, 1,
		GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    gtk_widget_show (cxpmail->list_view);

    /* GtkText åȤ˿ľСɲ */
    vscrollbar = gtk_vscrollbar_new (GTK_TEXT (cxpmail->list_view)->vadj);
    gtk_table_attach (GTK_TABLE (table), vscrollbar, 1, 2, 0, 1,
		GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    gtk_widget_show (vscrollbar);

    /* åȤμβǥɥ뤳Ȥǡƥ */
    gtk_widget_realize (cxpmail->list_view);


#if 0

    /* Clist Τ뤿Υɥɥ */
    cxpmail->swin_view = gtk_scrolled_window_new(NULL, NULL);

    /* ʿӿľΥСɽ褦 */
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(cxpmail->swin_view),
	GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_widget_show(cxpmail->swin_view);

    cxpmail->list_view = gtk_text_new (NULL, NULL);
    gtk_text_set_editable (GTK_TEXT (cxpmail->list_view), FALSE);
    gtk_widget_show (cxpmail->list_view);

    /* åȤμβǥɥ뤳Ȥǡƥ */
    gtk_widget_realize (cxpmail->list_view);

    gtk_widget_set_usize(cxpmail->list_view, 400, -1);

    gtk_signal_connect_object(GTK_OBJECT(cxpmail->list_view), "event",
	GTK_SIGNAL_FUNC(listbuttonpress), NULL);

    gtk_container_add(GTK_CONTAINER(cxpmail->swin_view), cxpmail->list_view);
    gtk_widget_show(cxpmail->list_view);

    hbox = gtk_hbox_new(TRUE, 0);
    gtk_box_pack_start(GTK_BOX(cxpmail->vbox), hbox, TRUE, TRUE, 1);
    gtk_widget_show(hbox);

    gtk_box_pack_start (GTK_BOX (hbox), cxpmail->swin_view, TRUE, TRUE, 5);

#endif

}

int cxpmail_view_view()
{
    int nn,xx ;
    char *ptr, *dptr ;
    int dsize, osize,ss;
    int saveSize ;

    ss = cxpmail->select_title ;
    nn = cxpmail->minfo.viewPoint ;

#ifdef DEBUG
fprintf(stdout,"cxpmail_view_view function start ...\n");
#endif

    /* ɽ */
    gtk_text_freeze( GTK_TEXT(cxpmail->list_view) );

    cxpmail_view_clean() ;

#ifdef DEBUG
fprintf(stdout, "cxpmail->select_title    -> %d\n", ss );
fprintf(stdout, "cxpmail->minfo.viewPoint -> %d\n", nn );
#endif

    if ( ss <= 0 )
    {
#ifdef DEBUG
fprintf(stdout,"error ...\n");
#endif

	/* ɽ */
	gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

	return(0);
    }

#ifdef DEBUG
    if ( cxpmail->minfo.box[nn] != (BoxInfo *)NULL )
	fprintf(stdout, "cxpmail->minfo.box[nn]->count -> %d\n", cxpmail->minfo.box[nn]->count);
#endif

    if ( cxpmail->minfo.box[nn] == (BoxInfo *)NULL )
	return(0);

    if ( cxpmail->minfo.box[nn]->count < ss )
    {
#ifdef DEBUG
fprintf(stdout,"check 1 -> %d\n", cxpmail->minfo.box[nn]->count );
fprintf(stdout,"check 2 -> %d\n", ss );
fprintf(stdout,"error ...\n");
#endif
	/* ɽ */
	gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

	return(0);
    }

#ifdef DEBUG
fprintf(stdout,"data view section \n");
fprintf(stdout,"cxpmail->minfo.box[nn]->mail[ss-1]->no -> %d\n",
		cxpmail->minfo.box[nn]->mail[ss-1]->no );
#endif

    saveSize = cxpmail->minfo.box[nn]->mail[ss-1]->size ;
    getMailData( cxpmail->minfo.box[nn], &(cxpmail->minfo.box[nn]->mail[ss-1]) );
    if ( saveSize != cxpmail->minfo.box[nn]->mail[ss-1]->size )
    {
	/* ׵ᤷȼۤʤˤϥإå򹹿 */
	setMailHeader( nn );
    }

    if ( cxpmail->minfo.box[nn]->mail[ss-1]->data == NULL )
    {
#ifdef DEBUG
fprintf(stdout,"data NULL\n");
#endif

	/* ɽ */
	gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

	return(0);
    }else{

	ptr = (char *)getNativeMailData( &dsize,
		cxpmail->minfo.box[nn]->mail[ss-1]->data,
		cxpmail->minfo.box[nn]->mail[ss-1]->size );
	if ( dsize <= 0 )
	{
#ifdef DEBUG
fprintf(stdout,"dsize is ZERO\n");
#endif
	    /* ɽ */
	    gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

	    return(0);
	}else{
	    dptr = malloc(dsize);
	    if ( dptr == (char *)NULL )
	    {
#ifdef DEBUG
fprintf(stdout,"malloc error\n");
#endif
		/* ɽ */
		gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

		free(ptr);
		return(0);
	    }else{
#ifdef DEBUG
fprintf(stdout,"data view ...\n");
#endif

		cxpmail_recvdata_euc( ptr, dsize, dptr, &osize );

#ifdef DEBUG
fprintf(stdout,"osize -> [%d]\n", osize );
fprintf(stdout,"dptr -> [%s]\n", dptr );
#endif

		gtk_text_set_point( GTK_TEXT(cxpmail->list_view), 0 );
		gtk_text_insert (GTK_TEXT(cxpmail->list_view),
			cxpmail->font, NULL, NULL, dptr, osize);
		free(ptr);
		free(dptr);
	    }
	}
    }

    /* ƬˤäƤ */
    gtk_text_set_point( GTK_TEXT(cxpmail->list_view), 0 );

    /* ɽ */
    gtk_text_thaw( GTK_TEXT(cxpmail->list_view) );

    return(0);
}


int cxpmail_view_clean()
{
    gtk_text_set_point( GTK_TEXT(cxpmail->list_view), 0 );
    gtk_text_forward_delete( GTK_TEXT(cxpmail->list_view),
	gtk_text_get_length(GTK_TEXT(cxpmail->list_view)));
}
