/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern	CxpNote    *cxpnote;

static GtkWidget *radbtn[4] ;

static void cxpnotedlg_cancel(GtkWidget *widget, gpointer data)
{
  /* ɥϥɤ */
  gtk_widget_hide( widget );
}

static void cxpnotedlg_set(GtkWidget *widget, gpointer data)
{
  if ((GTK_TOGGLE_BUTTON (radbtn[0])->active))
	cxpnote->color = 0 ;
  else
	cxpnote->color = 1 ;

  /* ɥϥɤ */
  gtk_widget_hide( widget );
}

void cxpnote_color_dialog ( title, ok, can  )
char	*title ;
char	*ok ;
char	*can ;
{
  GtkWidget *dialog ;
  GtkWidget *hbox ;
  GtkWidget *label ;
  GtkWidget *btn[4] ;
  char work[256] ;
  int	x,y,w,h ;

  gdk_window_get_origin(cxpnote->window->window, &x, &y);
  gdk_window_get_size  (cxpnote->window->window, &w, &h);

  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), title );

  gtk_widget_set_usize(dialog, 300, 150);
  gtk_widget_set_uposition(dialog, (x+(w/2)) - (400/2), (y+(h/2)) - (140/2));
  gtk_widget_show (dialog);

#if 0
+---+-------------------------------------------+
|  0|                                           |
|  1| ɽƥȤοʬɽǽ              |
|  2|                                           |
|  3|        ʬɽʤ[侩]           |
|  4|        ʬɽ                   |
|  8|                                           |
|   +-------------------------------------------+
|   | [  ]                      [ Ĥ ]  |
+---+-------------------------------------------+
#endif

#if 0
  hbox = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox,FALSE,FALSE,5 );
  gtk_widget_show (hbox);
#endif

  /* ȥ */
  strcpy( work, "ɽƥȤοʬɽǽ" );
  label  = gtk_label_new( work );
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, FALSE, 20 );
  gtk_widget_show (label);

  /* ȥ */

  radbtn[0] = gtk_radio_button_new_with_label (NULL,
	"ʬɽʤ[侩]");
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radbtn[0]), TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialog)->vbox), radbtn[0], TRUE, TRUE, 0);
  gtk_widget_show (radbtn[0]);

  radbtn[1] = gtk_radio_button_new_with_label (
	gtk_radio_button_group (GTK_RADIO_BUTTON (radbtn[0])),
	"ʬɽ");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialog)->vbox), radbtn[1], TRUE, TRUE, 0);
  gtk_widget_show (radbtn[1]);

  /* ܥ */
  btn[0] = gtk_button_new_with_label (ok);
  gtk_signal_connect_object (GTK_OBJECT (btn[0]), "clicked",
			(GtkSignalFunc) cxpnotedlg_set,
			GTK_OBJECT (dialog));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		btn[0], FALSE, TRUE, 10);
  gtk_widget_show (btn[0]);

  btn[1] = gtk_button_new_with_label (can);
  gtk_signal_connect_object (GTK_OBJECT (btn[1]), "clicked",
			(GtkSignalFunc) cxpnotedlg_cancel,
			GTK_OBJECT (dialog));
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		btn[1], FALSE, TRUE, 10);
  gtk_widget_show (btn[1]);

}
