/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern CxpSysinfo    *cxpsysinfo;

static char *clist_title[2] =
{
	"̾",
	""
};

void cxpsysinfo_list_init()
{
  GtkWidget	*hbox ;

  hbox = gtk_hbox_new( FALSE, 1);
  gtk_box_pack_start(GTK_BOX(cxpsysinfo->vbox), hbox, TRUE, TRUE, 5);
  gtk_widget_show(hbox);

  /* Clist Τ뤿Υɥɥ */
  cxpsysinfo->swin = gtk_scrolled_window_new(NULL, NULL);

  /* ʿӿľΥСɽ褦 */
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(cxpsysinfo->swin), 
	 	GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  gtk_box_pack_start(GTK_BOX(hbox), cxpsysinfo->swin, TRUE, TRUE, 5);
  gtk_widget_show(cxpsysinfo->swin);

  cxpsysinfo->clist = gtk_clist_new_with_titles( 2, clist_title );

  gtk_widget_set_usize(cxpsysinfo->clist, 300, -1);
  gtk_clist_set_selection_mode(GTK_CLIST(cxpsysinfo->clist),
				GTK_SELECTION_EXTENDED);

#if 0
  gtk_signal_connect(GTK_OBJECT(cxpsysinfo->clist),
		"select_row", GTK_SIGNAL_FUNC(clist_selection), NULL);

  gtk_signal_connect(GTK_OBJECT(cxpsysinfo->clist),
		"unselect_row", GTK_SIGNAL_FUNC(clist_unselection), NULL);
#endif

  /* ȥܥȤʤ褦ˤ롣*/
  gtk_clist_column_titles_passive( GTK_CLIST(cxpsysinfo->clist));

  gtk_clist_set_column_width(GTK_CLIST(cxpsysinfo->clist), 0, 100);
  gtk_clist_set_column_width(GTK_CLIST(cxpsysinfo->clist), 1, 100);

  gtk_container_add(GTK_CONTAINER(cxpsysinfo->swin), cxpsysinfo->clist);
  gtk_widget_show(cxpsysinfo->clist);


}
