/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

/* Ͽץꥱɤ߹ */
int getApplicationName( info )
APLICATION	*info ;
{
	FILE	*fp ;
	char	buff[1024] ;
	char	work[1024] ;
	char	filename[1024] ;
	char	*ptr ;
	int	kensu ;

	info->num = 0 ;

	sprintf( filename, "%s/.cxp/lib/application.cfg", (char*)getenv("HOME") );
	if ( access( filename, F_OK ) )
	{
		/* ե뤬¸ߤʤä饷ƥΥǡ */
		strcpy( filename, (char *)getPath(CXPSYSTEM_APPLICATION) );
	}

	if ( (fp = fopen( filename, "r" )) == NULL )
	{
		fprintf(stdout,"Entry Application file open error [%s]\n",
				filename );
		return(-1);
	}

	memset( buff, 0x00, sizeof(buff) );
	while( fgets( buff, sizeof(buff), fp) != 0)
	{
	    if (( buff[0] == '#'  ) ||  ( buff[0] == '\n' )
	    ||  ( buff[0] == '\t' ) ||  ( buff[0] == ' '  ))
		continue ;

	    /* Ͽ̾μФ */
	    memcpy( work, buff, sizeof(buff) );
	    ptr = nstrchr ( work, '"', 2 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( work, '"', 1 );
	    info->item[info->num].name = g_strdup( (char *)getPath(ptr+1) );

	    /* ¹ԥѥμФ */
	    memcpy( work, buff, sizeof(buff) );
	    ptr = nstrchr ( work, '"', 4 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( work, '"', 3 );
	    info->item[info->num].path = g_strdup( (char *)getPath(ptr+1) );

	    info->num ++ ;
	}

	fclose( fp );

	return( 0 );
}

int setApplicationName( info )
APLICATION	*info ;
{
	FILE	*fp ;
	char	filename[512] ;
	int	i ;

	sprintf( filename, "%s/.cxp", (char*)getenv("HOME") );
	if ( access( filename, F_OK ) )
	{
	    /* ǥ쥯ȥ꤬ʤä */
	    mkdir ( filename, 0755 );
	}
	sprintf( filename, "%s/.cxp/lib", (char*)getenv("HOME") );
	if ( access( filename, F_OK ) )
	{
	    /* ǥ쥯ȥ꤬ʤä */
	    mkdir ( filename, 0755 );
	}

	sprintf( filename, "%s/.cxp/lib/application.cfg", (char*)getenv("HOME") );
	if ( (fp = fopen( filename, "w" )) == NULL )
		return(-1);

	fprintf( fp, "#\n" );
	fprintf( fp, "# application.cfg "
		     "( cxplorer entry applicaion name Version 1.00)\n" );
	fprintf( fp, "# author: konta (hatakeda@mbm.sphere.ne.jp)\n" );
	fprintf( fp, "#\n" );
	fprintf( fp, "# Usage : \"name\"%c \"path\"\n", 0x2c );
	fprintf( fp, "#\n" );
	fprintf( fp, "# name    : Ͽץꥱ̾\n" );
	fprintf( fp, "# path    : ¹ԥե̾\n" );
	fprintf( fp, "#\n" );
	fprintf( fp, "\n" );

	for(i=0;i<info->num;i++)
	{
		fprintf( fp, "\"%s\"%c\"%s\"\n",
		info->item[i].name, 0x2c,
		info->item[i].path );
	}

	fclose(fp);

	return(0);
}
