/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

/* եξեɤ߹ */
int getStyleConfig( index, style )
int		*index ;
STYLEINFO	*style ;
{
	DIR     *dfd;
	struct dirent *dp ;
	FILE	*fp ;
	char	styleName[1024] ;
	char	configbuff[1024] ;
	char	workbuff[1024] ;
	char	dirName[1024] ;
	char	*ptr, *ptr2 ;
	int	status ;
	int	n ;
	int	i ;
	int	ii ;

	status = 0 ;
	(*index) = -1 ;

	/*-- ǥ쥯ȥΥץ --*/
	sprintf( dirName, "%s", getPath(CXPSYSTEM_STYLE) );
	if ( (dfd = opendir(dirName)) == NULL )
                return(-1);

	ii = 0 ;
	for(i=1; (dp = readdir(dfd)) != NULL; i++)
	{
	    if ( !strcmp( dp->d_name, "." ) || !strcmp( dp->d_name, "..") )
		continue ;

	    sprintf( styleName, "%s/%s/info.cfg",
			getPath(CXPSYSTEM_STYLE), dp->d_name );

	    if ( (fp = fopen( styleName, "r" )) == NULL )
		continue ;
	    memset( configbuff, 0x00, sizeof(configbuff) );
	    while( fgets( configbuff, sizeof(configbuff), fp) != 0)
	    {
		if (( configbuff[0] == '#'  ) ||  ( configbuff[0] == '\n' )
		||  ( configbuff[0] == '\t' ) ||  ( configbuff[0] == ' '  ))
			continue ;

		if ( !strncmp( configbuff, "NAME=",
						strlen("NAME=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].name = g_strdup( ptr+1 );
	        }
		if ( !strncmp( configbuff, "TREEINFO1=",
						strlen("TREEINFO1=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].treexpm1 = g_strdup( (char *)getPath(ptr+1) );
	        }
		if ( !strncmp( configbuff, "TREEINFO2=",
						strlen("TREEINFO2=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].treexpm2 = g_strdup( (char *)getPath(ptr+1));
		}
		if ( !strncmp( configbuff, "TREEINFO3=",
						strlen("TREEINFO3=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].treexpm3 = g_strdup( (char *)getPath(ptr+1) );
		}
		if ( !strncmp( configbuff, "FILEINFO=",
						strlen("FILEINFO=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].filexpm = g_strdup( (char *)getPath(ptr+1) );
		}
		if ( !strncmp( configbuff, "UNKNOWN=",
						strlen("UNKNOWN=") ) )
		{
		    memcpy( workbuff, configbuff, sizeof(configbuff) );
		    ptr = nstrchr ( workbuff, '"', 2 );
		    *ptr = 0x00 ;
		    ptr = nstrchr ( workbuff, '"', 1 );
		    style[ii].unknown = g_strdup( (char *)getPath(ptr+1) );

		}
	    }
	    fclose( fp );

	    if ( style[ii].name == NULL
	    ||   style[ii].treexpm1 == NULL
	    ||   style[ii].treexpm2 == NULL
	    ||   style[ii].treexpm3 == NULL
	    ||   style[ii].filexpm == NULL
	    ||   style[ii].unknown == NULL )
	    {
		continue ;
	    }

	    style[ii].flag = 1 ;
	    status++;
	    if ( (*index) == -1 )
		(*index) = ii ;
	    ii++;
	}

	/*-- ǥ쥯ȥΥ --*/
	closedir(dfd);

	return(status);
}
