/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern	CxpAddr    *cxpaddr;

static GtkWidget *cxpaddr_textwid[32] ;
static int	_setAddresNo ;

static char *_getData( int no )
{
    char *ptr ;

    ptr = gtk_entry_get_text(GTK_ENTRY(cxpaddr_textwid[no]));
    if ( ptr == NULL )
	return("");
    return(ptr);
}

static void cxpaddrdlg_cancel(GtkWidget *widget, gpointer data)
{
  /* ɥϥɤ */
/*
  gtk_grab_remove ( widget );
*/
  gtk_widget_hide( widget );
}

static void cxpaddrdlg_set(GtkWidget *widget, gpointer data)
{
  int no ;
  char *setname[12];

  if ( _setAddresNo >= 0 )
  {
	no = _setAddresNo ;
  }else{
	no = cxpaddr->addr_kensu ;
	cxpaddr->addr_kensu ++;
  }
  cxpaddr->addr[no].name    = g_strdup( _getData( 0 ) );
  cxpaddr->addr[no].kana    = g_strdup( _getData( 1 ) );
  cxpaddr->addr[no].sex     = g_strdup( _getData( 2 ) );
  cxpaddr->addr[no].bload   = g_strdup( _getData( 3 ) );
  cxpaddr->addr[no].birth   = g_strdup( _getData( 4 ) );
  cxpaddr->addr[no].job     = g_strdup( _getData( 5 ) );
  cxpaddr->addr[no].jtel    = g_strdup( _getData( 6 ) );
  cxpaddr->addr[no].ybin    = g_strdup( _getData( 7 ) );
  cxpaddr->addr[no].addr    = g_strdup( _getData( 8 ) );
  cxpaddr->addr[no].tel     = g_strdup( _getData( 9 ) );
  cxpaddr->addr[no].fax     = g_strdup( _getData( 10 ) );
  cxpaddr->addr[no].email   = g_strdup( _getData( 11 ) );
  cxpaddr->addr[no].website = g_strdup( _getData( 12 ) );
  cxpaddr->addr[no].comment = g_strdup( _getData( 13 ) );

  if ( _setAddresNo >= 0 )
  {
	gtk_clist_set_text (GTK_CLIST(cxpaddr->clist),no,0, _getData( 0 ) );
	gtk_clist_set_text (GTK_CLIST(cxpaddr->clist),no,1, _getData( 11) );
	gtk_clist_set_text (GTK_CLIST(cxpaddr->clist),no,2, _getData( 5 ) );
	gtk_clist_set_text (GTK_CLIST(cxpaddr->clist),no,3, _getData( 2 ) );
	gtk_clist_set_text (GTK_CLIST(cxpaddr->clist),no,4, _getData( 6 ) );

  }else{
	setname[0] = g_strdup( cxpaddr->addr[no].name );
	setname[1] = g_strdup( cxpaddr->addr[no].email );
	setname[2] = g_strdup( cxpaddr->addr[no].job  );
	setname[3] = g_strdup( cxpaddr->addr[no].sex  );
	setname[4] = g_strdup( cxpaddr->addr[no].jtel );
	gtk_clist_append( GTK_CLIST(cxpaddr->clist), setname );
  }

  /* ɥϥɤ */
/*
  gtk_grab_remove ( widget );
*/
  gtk_widget_hide( widget );
}

void cxpaddr_dialog ( title, ok, can, no  )
char	*title ;
char	*ok ;
char	*can ;
int	no ;	/* -1 : ɲ / >=0 : ѹ */
{
  GtkWidget *dialog ;
  GtkWidget *hbox[32] ;
  GtkWidget *label[32] ;
  GtkWidget *btn[4] ;
  GtkWidget *sepa ;
  int x,y,w,h ;
  char	*ptr ;

  gdk_window_get_origin(cxpaddr->window->window, &x, &y);
  gdk_window_get_size  (cxpaddr->window->window, &w, &h);

  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), title );
#if 0
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
#endif

  gtk_widget_set_usize(dialog, 600, 340);
  gtk_widget_set_uposition(dialog, (x+(w/2)) - (600/2), (y+(h/2)) - (340/2));
  gtk_widget_show (dialog);

/*
  gtk_grab_add (dialog);
*/

#if 0
+---+------------------------------------------------------------------+
|  0| ̾[                       ] ɤ[                    ] |
|  1| ̡[      ] շ[      ] ǯ[                  ] |
|  2| ̾[                       ] Ϣ衧[                    ] |
|  3| ͹ֹ桧[         ]                                            |
|  4| ꡧ[                                                      ] |
|  5| ֹ桧[                 ] ƣֹ桧[                    ] |
|  6| Żҥ᡼롧[                                                  ] |
|  7| ۡڡ[                                                ] |
|  8| ȡ[                                                    ] |
|   +------------------------------------------------------------------+
|   | [ ɲ/ѹ ]                                        [ Ĥ ]  |
+---+------------------------------------------------------------------+
#endif

  /* ̾ɤ */
  hbox[0] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[0],FALSE,FALSE,5 );
  gtk_widget_show (hbox[0]);

  label[0]  = gtk_label_new( "̾" );
  gtk_box_pack_start (GTK_BOX(hbox[0]), label[0], FALSE, FALSE, 5 );
  gtk_widget_show (label[0]);

  cxpaddr_textwid[0]  = gtk_entry_new_with_max_length( 256 );
  gtk_box_pack_start (GTK_BOX(hbox[0]), cxpaddr_textwid[0], FALSE, FALSE, 0 );
  gtk_widget_set_usize (cxpaddr_textwid[0], 200, -1);
  gtk_widget_show (cxpaddr_textwid[0]);

  label[1]  = gtk_label_new( "ɤ" );
  gtk_box_pack_start (GTK_BOX(hbox[0]), label[1], FALSE, FALSE, 5 );
  gtk_widget_show (label[1]);

  cxpaddr_textwid[1]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[1], 200, -1);
  gtk_box_pack_start (GTK_BOX(hbox[0]), cxpaddr_textwid[1], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[1]);




  /* ̡շǯ */
  hbox[1] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[1],FALSE,FALSE,5 );
  gtk_widget_show (hbox[1]);

  label[2]  = gtk_label_new( "̡" );
  gtk_box_pack_start (GTK_BOX(hbox[1]), label[2], FALSE, FALSE, 5 );
  gtk_widget_show (label[2]);

  cxpaddr_textwid[2]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[2], 50, -1);
  gtk_box_pack_start (GTK_BOX(hbox[1]), cxpaddr_textwid[2], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[2]);

  label[3]  = gtk_label_new( "շ" );
  gtk_box_pack_start (GTK_BOX(hbox[1]), label[3], FALSE, FALSE, 5 );
  gtk_widget_show (label[3]);

  cxpaddr_textwid[3]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[3], 50, -1);
  gtk_box_pack_start (GTK_BOX(hbox[1]), cxpaddr_textwid[3], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[3]);

  label[4]  = gtk_label_new( "ǯ" );
  gtk_box_pack_start (GTK_BOX(hbox[1]), label[4], FALSE, FALSE, 5 );
  gtk_widget_show (label[4]);

  cxpaddr_textwid[4]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[4], 100, -1);
  gtk_box_pack_start (GTK_BOX(hbox[1]), cxpaddr_textwid[4], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[4]);




  /* ̾ */
  hbox[2] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[2],FALSE,FALSE,5 );
  gtk_widget_show (hbox[2]);

  label[5]  = gtk_label_new( "̾ع̾" );
  gtk_box_pack_start (GTK_BOX(hbox[2]), label[5], FALSE, FALSE, 5 );
  gtk_widget_show (label[5]);

  cxpaddr_textwid[5]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[5], 300, -1);
  gtk_box_pack_start (GTK_BOX(hbox[2]), cxpaddr_textwid[5], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[5]);

  label[6]  = gtk_label_new( "Ϣ衧" );
  gtk_box_pack_start (GTK_BOX(hbox[2]), label[6], FALSE, FALSE, 5 );
  gtk_widget_show (label[6]);

  cxpaddr_textwid[6]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[6], 100, -1);
  gtk_box_pack_start (GTK_BOX(hbox[2]), cxpaddr_textwid[6], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[6]);




  /* ͹ֹ */
  hbox[3] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[3],FALSE,FALSE,5 );
  gtk_widget_show (hbox[3]);

  label[7]  = gtk_label_new( "͹ֹ桧" );
  gtk_box_pack_start (GTK_BOX(hbox[3]), label[7], FALSE, FALSE, 5 );
  gtk_widget_show (label[7]);

  cxpaddr_textwid[7]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[7], 50, -1);
  gtk_box_pack_start (GTK_BOX(hbox[3]), cxpaddr_textwid[7], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[7]);



  /*  */
  hbox[4] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[4],FALSE,FALSE,5 );
  gtk_widget_show (hbox[4]);

  label[8]  = gtk_label_new( "ꡧ" );
  gtk_box_pack_start (GTK_BOX(hbox[4]), label[8], FALSE, FALSE, 5 );
  gtk_widget_show (label[8]);

  cxpaddr_textwid[8]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[8], 400, -1);
  gtk_box_pack_start (GTK_BOX(hbox[4]), cxpaddr_textwid[8], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[8]);




  /* ֹ桿ƣֹ */
  hbox[5] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[5],FALSE,FALSE,5 );
  gtk_widget_show (hbox[5]);

  label[9]  = gtk_label_new( "ֹ桧" );
  gtk_box_pack_start (GTK_BOX(hbox[5]), label[9], FALSE, FALSE, 5 );
  gtk_widget_show (label[9]);

  cxpaddr_textwid[9]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[9], 100, -1);
  gtk_box_pack_start (GTK_BOX(hbox[5]), cxpaddr_textwid[9], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[9]);

  label[10] = gtk_label_new( "ƣֹ桧" );
  gtk_box_pack_start (GTK_BOX(hbox[5]), label[10], FALSE, FALSE, 5 );
  gtk_widget_show (label[10]);

  cxpaddr_textwid[10]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[10], 100, -1);
  gtk_box_pack_start (GTK_BOX(hbox[5]), cxpaddr_textwid[10], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[10]);




  /* Żҥ᡼ */
  hbox[6] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[6],FALSE,FALSE,5 );
  gtk_widget_show (hbox[6]);

  label[11] = gtk_label_new( "Żҥ᡼롧" );
  gtk_box_pack_start (GTK_BOX(hbox[6]), label[11], FALSE, FALSE, 5 );
  gtk_widget_show (label[11]);

  cxpaddr_textwid[11]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[11], 150, -1);
  gtk_box_pack_start (GTK_BOX(hbox[6]), cxpaddr_textwid[11], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[11]);




  /* ۡڡ */
  hbox[7] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[7],FALSE,FALSE,5 );
  gtk_widget_show (hbox[7]);

  label[12] = gtk_label_new( "ۡڡ" );
  gtk_box_pack_start (GTK_BOX(hbox[7]), label[12], FALSE, FALSE, 5 );
  gtk_widget_show (label[12]);

  cxpaddr_textwid[12]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[12], 300, -1);
  gtk_box_pack_start (GTK_BOX(hbox[7]), cxpaddr_textwid[12], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[12]);




  /*  */
  hbox[8] = gtk_hbox_new( FALSE, 2);
  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox[8],FALSE,FALSE,5 );
  gtk_widget_show (hbox[8]);

  label[13] = gtk_label_new( "ȡ" );
  gtk_box_pack_start (GTK_BOX(hbox[8]), label[13], FALSE, FALSE, 5 );
  gtk_widget_show (label[13]);

  cxpaddr_textwid[13]  = gtk_entry_new_with_max_length( 256 );
  gtk_widget_set_usize (cxpaddr_textwid[13], 400, -1);
  gtk_box_pack_start (GTK_BOX(hbox[8]), cxpaddr_textwid[13], FALSE, FALSE, 0 );
  gtk_widget_show (cxpaddr_textwid[13]);




  /* ܥ */
  btn[0] = gtk_button_new_with_label (ok);
  gtk_signal_connect_object (GTK_OBJECT (btn[0]), "clicked",
			(GtkSignalFunc) cxpaddrdlg_set,
			GTK_OBJECT (dialog));
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		btn[0], FALSE, TRUE, 10);
  gtk_widget_show (btn[0]);

  btn[1] = gtk_button_new_with_label (can);
  gtk_signal_connect_object (GTK_OBJECT (btn[1]), "clicked",
			(GtkSignalFunc) cxpaddrdlg_cancel,
			GTK_OBJECT (dialog));
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		btn[1], FALSE, TRUE, 10);
  gtk_widget_show (btn[1]);


  if ( no >= 0 )
  {
#ifdef	DEBUG
fprintf(stdout,"no -> [%d]\n", no );
fprintf(stdout,"%s\n", cxpaddr->addr[no].name );
fprintf(stdout,"%s\n", cxpaddr->addr[no].kana );
fprintf(stdout,"%s\n", cxpaddr->addr[no].sex );
fprintf(stdout,"%s\n", cxpaddr->addr[no].bload );
fprintf(stdout,"%s\n", cxpaddr->addr[no].birth );
fprintf(stdout,"%s\n", cxpaddr->addr[no].job );
fprintf(stdout,"%s\n", cxpaddr->addr[no].jtel );
fprintf(stdout,"%s\n", cxpaddr->addr[no].ybin );
fprintf(stdout,"%s\n", cxpaddr->addr[no].addr );
fprintf(stdout,"%s\n", cxpaddr->addr[no].tel );
fprintf(stdout,"%s\n", cxpaddr->addr[no].fax );
fprintf(stdout,"%s\n", cxpaddr->addr[no].email );
fprintf(stdout,"%s\n", cxpaddr->addr[no].website );
fprintf(stdout,"%s\n", cxpaddr->addr[no].comment );
fflush(stdout);
#endif
	/* ѹ⡼ */
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[0]), cxpaddr->addr[no].name );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[1]), cxpaddr->addr[no].kana );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[2]), cxpaddr->addr[no].sex );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[3]), cxpaddr->addr[no].bload );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[4]), cxpaddr->addr[no].birth );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[5]), cxpaddr->addr[no].job );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[6]), cxpaddr->addr[no].jtel );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[7]), cxpaddr->addr[no].ybin );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[8]), cxpaddr->addr[no].addr );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[9]), cxpaddr->addr[no].tel );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[10]),cxpaddr->addr[no].fax );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[11]),cxpaddr->addr[no].email );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[12]),cxpaddr->addr[no].website );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[13]),cxpaddr->addr[no].comment );

	_setAddresNo = no ;

  }else{
	/* ɲå⡼ */

	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[0]), "̵̾θʼ" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[1]), "ʤʤΤ٤" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[2]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[3]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[4]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[5]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[6]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[7]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[8]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[9]), "" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[10]),"" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[11]),"" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[12]),"http://" );
	gtk_entry_set_text(GTK_ENTRY(cxpaddr_textwid[13]),"" );

	_setAddresNo = -1 ;
  }

}
