/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

CxpApp    *cxpapp;

/*
 * Cxpapp Version Header
 *
 * version  date        log
 *  1.0.0   1999/08/23  first released.
 *  1.0.1   1999/09/07  file dialog set bug fix.
 *  1.0.2   2000/04/17  main exit code is ZERO add.
 *  1.0.3   2000/08/01  cxpmanager start add.
 *                      XPM => ICON label name change.
 *
 */

extern int  getApplicationConfig() ;

void cxpapp_init()
{
  GtkWidget	*hpaned;
  GtkWidget	*vbox;
  GtkWidget	*subitem ;
  int		row ;

  cxpapp = (CxpApp *)g_malloc(sizeof(CxpApp));

  /* ưɣĤμ */
  cxpapp->uid = getuid();
  cxpapp->gid = getgid();

  /* ν */
  cxpapp->selectrow = -1 ;
  cxpapp->currentViewFlag = 0 ;
  cxpapp->clist_timeout_start = 0 ;
  cxpapp->clist_timeout_end   = 0 ;

  /* ץꥱɤ߹ */
  getApplicationConfig( &(cxpapp->appli_kensu), &(cxpapp->appli) );

  /* ١Υɥ */
  cxpapp->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect(GTK_OBJECT(cxpapp->window), "destroy",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_window_set_title(GTK_WINDOW(cxpapp->window), "Cxpapp" );
  gtk_widget_set_usize(cxpapp->window, 440, 300);

  /* ɥɽ */
  gtk_widget_show(cxpapp->window);


  /* VBOX */
  cxpapp->vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(cxpapp->window), cxpapp->vbox);
  gtk_widget_show(cxpapp->vbox);

  /*  */
  cxpapp_list_init() ;

  /* ˥ǡɽ */
  cxpapp_view();

  return;
}

int main(int argc, char *argv[])
{
	CxpBasePathInit();

	/* ޥ͡㵯ư */

	gtk_set_locale();
	gtk_init(&argc, &argv);
  
	cxpapp_init();

	gtk_main();
	exit(0);
}
