/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpbackup.h"

CxpBackup *cxpbackup ;

extern void sigChildFunc();

main( int argc, char *argv[] )
{
    struct sigaction sigChildAct ;

    CxpBasePathInit();

    /* ޥ͡㵯ư */
    cxp_manager_start();

    cxpbackup = (CxpBackup *)g_malloc(sizeof(CxpBackup));
    memset(cxpbackup,0x00,sizeof(CxpBackup));

    /* ưɣĤμ */
    cxpbackup->uid = getuid();
    cxpbackup->gid = getgid();
    cxpbackup->pid = getpid();

    /* ١ɤ߹ */
    getBaseConfig( &cxpbackup->base ) ;

    /* ǥХɤ߹ */
    getDeviceConfig( &cxpbackup->devinf ) ;


    /* ʥ */
    sigChildAct.sa_flags   = 0 ;
    sigChildAct.sa_handler = sigChildFunc ;
    sigfillset(&sigChildAct.sa_mask);
    sigaction( SIGCHLD, &sigChildAct, NULL);

    gtk_set_locale();
    gtk_init (&argc, &argv);

    cxpbackup_start();

    gtk_main();
    exit(0) ;
}
