/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpbackup.h"

extern CxpBackup *cxpbackup ;

extern int showWindowAppend();
extern int startShowInit();
extern int endShowItem();

/* ܺ٤ɲ */
int showWindowAppend()
{
    char *showName;
    char *viewname[2] ;
    char buff[1024] ;
    char command[1024];
    int  cc ;
    char *data ;
    int  size ;
    int totalsize ;
    int i, k, ken ;
    struct stat fileinfo ;

#ifdef DEBUG8
fprintf(stdout,"--- append start \n");
#endif

    sprintf( command,"%s.show", cxpbackup->normalLog );
    showName = g_strdup(command);

    sprintf( command,"cp %s %s", cxpbackup->normalLog, showName );
    system( command );

    stat( showName, &fileinfo );
    totalsize = fileinfo.st_size ;

    if ( (cxpbackup->fpShow = fopen( showName, "r" )) == NULL )
	return(0); ;

#ifdef DEBUG8
fprintf(stdout,"totalsize => %d\n", totalsize);
#endif

    k = 0 ;
    memset( buff, 0x00, sizeof(buff) );
    ken = 0 ;
    for(i=0;i<totalsize;i++)
    {
	cc = fgetc(cxpbackup->fpShow);
	if ( (char)cc == '\n' )
	{
	    if ( ken >= cxpbackup->showKensu )
	    {
		viewname[0] == g_strdup(buff) ;
		gtk_clist_append( GTK_CLIST(cxpbackup->viewList), viewname );
		gtk_clist_moveto( GTK_CLIST(cxpbackup->viewList),
			cxpbackup->showKensu , 0, (gfloat)0.5, (gfloat)1.0 );
		cxpbackup->showKensu++;

#ifdef DEBUG8
fprintf(stdout,"--- data apeend [%s]\n", buff );
#endif
	    }
	    ken++;
	    memset( buff, 0x00, sizeof(buff) );
	    k =0 ;
	}else{
	    buff[k] = (char)cc ;
	    k++;
	}
    }

#ifdef DEBUG8
fprintf(stdout,"--- append end \n");
#endif

    fclose(cxpbackup->fpShow);
    remove(showName);
}

/* ܺٽ */
int startShowInit()
{
    int status ;

#ifdef DEBUG8
fprintf(stdout,"startShowInit start ...\n");
#endif

    if ( cxpbackup->normalLog == NULL )
    {
	cxpbackup->saveMode = 0 ;
    }else{
	cxpbackup->showKensu = 0;
	cxpbackup->saveMode = 1 ;
    }

#ifdef DEBUG8
fprintf(stdout,"startShowInit end ...\n");
#endif

    return( cxpbackup->saveMode );
}


/* λ */
int endShowItem()
{
#ifdef DEBUG8
fprintf(stdout,"endShowItem start ...\n");
#endif

    cxpbackup->saveMode = 0 ;

#ifdef DEBUG8
fprintf(stdout,"endShowItem end ...\n");
#endif
}
