/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpcalen.h"

extern CxpCalen *cxpcalen ;

char *getKindLabel( int kind )
{
	char *name ;

	switch( kind )
	{
	    case 0 :	name = "Ŀ" ;
			break ;
	    case 1 :	name = "Ż" ;
			break ;
	    case 2 :	name = "̣" ;
			break ;
	    case 3 :	name = "" ;
			break ;
	    case 4 :	name = "¾" ;
			break ;
	    default :	name = "" ;
			break ;
	}

	return(name);
}

char *getLebelLabel( int level )
{
	char *name ;

	switch( level )
	{
	    case 0 :	name = "̾" ;
			break ;
	    case 1 :	name = "" ;
			break ;
	    case 2 :	name = "۵" ;
			break ;
	    case 3 :	name = "¾" ;
			break ;
	    default :	name = "" ;
			break ;
	}

	return(name);
}

char *getAlarmLabel( int mode )
{
	char *name ;

	switch( mode )
	{
	    case 0 :	name = "ߥ顼ꤵƤޤ" ;
			break ;
	    case 1 :	name = "ߥ顼ꤵƤޤ" ;
			break ;
	    default :	name = "" ;
			break ;
	}

	return(name);
}
