/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpcalen.h"

extern CxpCalen *cxpcalen ;

void calendar_day_selected (GtkWidget *widget, gpointer *data)
{
    char        buffer[256];
    struct tm   tim;
    time_t      time;
    int		backyear ;
    int		backmon ;

#ifdef	DEBUG9
fprintf(stdout,"calendar_day_selected start ...\n");
#endif

    memset (&tim, 0, sizeof (tim));
    gtk_calendar_get_date (GTK_CALENDAR(cxpcalen->calendar1),
                        &tim.tm_year, &tim.tm_mon, &tim.tm_mday);

    backyear = cxpcalen->s_year ;
    backmon = cxpcalen->s_month ;

    cxpcalen->s_year  = tim.tm_year ;
    cxpcalen->s_month = tim.tm_mon + 1 ;
    cxpcalen->s_day   = tim.tm_mday ;

#ifdef	DEBUG9
fprintf(stdout,"calendar_day_selected s_year  => %d\n", cxpcalen->s_year );
fprintf(stdout,"calendar_day_selected s_month => %d\n", cxpcalen->s_month );
fprintf(stdout,"calendar_day_selected s_day   => %d\n", cxpcalen->s_day );
#endif

    if ( cxpcalen->selectview < 0 )
    {
#ifdef	DEBUG9
fprintf(stdout,"calendar_day_selected ɽ̤򤵤Ƥʤ\n");
#endif
	return ;
    }


    /* ǯۤʤˤϺ٥ǡɤ߹ */
    if ( backyear != cxpcalen->s_year )
    {
	/* ֹ */
	cxpcalen->selectday = cxpcalen->s_day - 1 ;

	/* ꤵ줿ɽ̤ξɤ߹ */  
	if ( cxpcalen->view.kensu > 0 )
	{
	    getCalenDataSchedule( cxpcalen->s_year,
		&cxpcalen->view.view[cxpcalen->selectview],
		&cxpcalen->data );
	}
#ifdef	DEBUG9
fprintf(stdout,"calendar_day_selected ǯۤʤ\n");
#endif
    }
#ifdef	DEBUG9
    else{
fprintf(stdout,"calendar_day_selected ǯƱ\n");
    }
#endif

    /* ǡ򹹿ƤϤʤ */
    if ( cxpcalen->notCalenSelectNotDataView == 0 )
    {
	/* Υǡɽ */
	viewMonthData();
    }else{
	cxpcalen->notCalenSelectNotDataView = 0 ;
    }

    /* Υǡɽ */
    viewDayData();

    /* 򤷤ǡƤɽ */
	;
	;
	;
	;
	;
	;
	;
	;
}
