/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpcalen.h"

extern CxpCalen *cxpcalen ;

/* ToDoɲå˥塼 */
int cxpcalentodofunc_add()
{
    TodoItem	*todoitem ;

    if ( cxpcalen->todo.kensu + 1 >= MAX_TODOLIST_NUM )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoϺ512ޤǤǤ" );
	return(0);
    }

    todoitem = (TodoItem *)NULL ;

    /* ɲ */
    create_todowindow ( todoitem, -1 );
}

/* ToDoԽ˥塼 */
int cxpcalentodofunc_mod()
{
    TodoItem	*todoitem ;

    if ( cxpcalen->todo.kensu <= 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡޤ" );
	return(0);
    }

    if ( cxpcalen->selecttodo < 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡ򤵤Ƥޤ");
	return(0);
    }

    if ( cxpcalen->selecttodo >= cxpcalen->todo.kensu )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡɽǡפޤ");
	return(0);
    }

#ifdef	DEBUG9
fprintf(stdout,"cxpcalentodofunc_mod selecttodo -> %d\n",cxpcalen->selecttodo );
#endif

    todoitem = (TodoItem *)&cxpcalen->todo.item[cxpcalen->selecttodo] ;

    /* ѹ */
    create_todowindow ( todoitem, cxpcalen->selecttodo );
}

int todoDeleteOkfunc( GtkWidget *widget, GtkWidget *win )
{
    int i ;

    if ( cxpcalen->todo.kensu <= 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡޤ" );
	return(0);
    }

    if ( cxpcalen->selecttodo < 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡ򤵤Ƥޤ");
	return(0);
    }

    if ( cxpcalen->selecttodo >= cxpcalen->todo.kensu )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡɽǡפޤ");
	return(0);
    }

    for(i=cxpcalen->selecttodo;i<cxpcalen->todo.kensu-1;i++)
    {
	cxpcalen->todo.item[i].level = cxpcalen->todo.item[i+1].level ;
	cxpcalen->todo.item[i].alarm.mode = cxpcalen->todo.item[i+1].alarm.mode ;
	cxpcalen->todo.item[i].alarm.year = cxpcalen->todo.item[i+1].alarm.year ;
	cxpcalen->todo.item[i].alarm.month = cxpcalen->todo.item[i+1].alarm.month ;
	cxpcalen->todo.item[i].alarm.day = cxpcalen->todo.item[i+1].alarm.day ;
	cxpcalen->todo.item[i].alarm.hour = cxpcalen->todo.item[i+1].alarm.hour ;
	cxpcalen->todo.item[i].alarm.min = cxpcalen->todo.item[i+1].alarm.min ;
	cxpcalen->todo.item[i].data = strdup(cxpcalen->todo.item[i+1].data) ;

	cxpcalen->todo.item[i+1].level = 0 ;
	cxpcalen->todo.item[i+1].alarm.mode = 0 ;
	cxpcalen->todo.item[i+1].alarm.year = 0 ;
	cxpcalen->todo.item[i+1].alarm.month = 0 ;
	cxpcalen->todo.item[i+1].alarm.day = 0 ;
	cxpcalen->todo.item[i+1].alarm.hour = 0 ;
	cxpcalen->todo.item[i+1].alarm.min = 0 ;
	cxpcalen->todo.item[i+1].data = (char *)NULL ;
    }

    cxpcalen->todo.kensu -- ;

    /* ǡ¸ */
    setCalenDataTodo( &cxpcalen->todo );

    /* ǡɽ */
    viewTodoData();

    gtk_widget_destroy(win);

    return(0);
}

/* ToDo˥塼 */
int cxpcalentodofunc_del()
{
    if ( cxpcalen->todo.kensu <= 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡޤ" );
	return(0);
    }

    if ( cxpcalen->selecttodo < 0 )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡ򤵤Ƥޤ");
	return(0);
    }

    if ( cxpcalen->selecttodo >= cxpcalen->todo.kensu )
    {
	create_messageWin ( cxpcalen->window,
		"ToDoǡɽǡפޤ");
	return(0);
    }

    create_messageWin2( cxpcalen->window,
		"򤷤ƤTodoޤ",
		todoDeleteOkfunc, NULL );
}


