/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpimageview.h"

extern CxpImageView *cxpimageview ;
static GtkWidget *stopBtn;

extern int stopSearchFunc();

int cxpimage_stopWindow ()
{
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *label1;
  GtkWidget *hbox1;

  cxpimageview->stopWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (cxpimageview->stopWindow), "stopWindow", cxpimageview->stopWindow);
  gtk_widget_set_usize (cxpimageview->stopWindow, 400, 100);
  gtk_window_set_title (GTK_WINDOW (cxpimageview->stopWindow), "");
  gtk_window_set_policy (GTK_WINDOW (cxpimageview->stopWindow), FALSE, FALSE, FALSE);
  gtk_widget_show(cxpimageview->stopWindow);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (cxpimageview->stopWindow), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (cxpimageview->stopWindow), vbox1);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (cxpimageview->stopWindow), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 20);

  label1 = gtk_label_new ("ǥ쥯ȥ꤫饤᡼ǡ򸡺Ƥޤ");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (cxpimageview->stopWindow), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (cxpimageview->stopWindow), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 5);

  stopBtn = gtk_button_new_with_label ("  ");
  gtk_widget_ref (stopBtn);
  gtk_object_set_data_full (GTK_OBJECT (cxpimageview->stopWindow), "stopBtn", stopBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stopBtn);
  gtk_box_pack_start (GTK_BOX (hbox1), stopBtn, FALSE, FALSE, 0);

  /* ܥ󥤥٥ */
  gtk_signal_connect_object (GTK_OBJECT (stopBtn), "clicked",
                (GtkSignalFunc)stopSearchFunc, GTK_OBJECT (cxpimageview->stopWindow));

}

