/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

extern	CxpMgr    *cxpmgr;

static char *Kakunin   = "Ĥ" ;

extern char *getdataJVersion() ;
extern char *getdataJEmail() ;
extern char *getdataJUrl() ;
extern char *getdataCopyright() ;

static void helpdialog_destroy(GtkWidget *widget, gpointer data)
{
  /* ɥϥɤ */
  gtk_grab_remove ( widget );
  gtk_widget_hide( widget );
}

void helpfunc_about ()
{
  GtkWidget *dialog ;
  GtkWidget *label[5] ;
  GtkWidget *button ;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap ;
  GdkBitmap *mask;
  GtkStyle  *style;
  int x,y,w,h ;

  gdk_window_get_origin(cxpmgr->window->window, &x, &y);
  gdk_window_get_size  (cxpmgr->window->window, &w, &h);

  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), "CxplorerˤĤ");
  gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
  gtk_widget_set_usize(dialog, 300, 210);
  gtk_widget_set_uposition(dialog, (x+(w/2)) - (300/2), (y+(h/2)) - (210/2));
  gtk_grab_add (dialog);
  gtk_widget_show (dialog);

  label[4] = gtk_label_new( getdataCopyright() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[4], FALSE, TRUE, 5);
  gtk_widget_show (label[4]);

  label[3] = gtk_label_new( getdataJEmail());
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[3], FALSE, TRUE, 5);
  gtk_widget_show (label[3]);

  label[2] = gtk_label_new( getdataJUrl() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[2], FALSE, TRUE, 5);
  gtk_widget_show (label[2]);

  label[1] = gtk_label_new( getdataJVersion() );
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label[1], FALSE, TRUE, 5);
  gtk_widget_show (label[1]);

  style = gtk_widget_get_style( cxpmgr->window );
  pixmap = gdk_pixmap_create_from_xpm(
                cxpmgr->window->window,
                &mask, &style->bg[GTK_STATE_NORMAL],
                cxpmgr->base.cxplorer );
  pixmapwid = gtk_pixmap_new (pixmap, mask);
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		pixmapwid, TRUE, TRUE, 0);
  gtk_widget_show (pixmapwid);


  button = gtk_button_new_with_label (Kakunin);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			(GtkSignalFunc) helpdialog_destroy,
			GTK_OBJECT (dialog));

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		button, FALSE, TRUE, 0);
  gtk_widget_show (button);

}
