/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpmail.h"  
                
extern CxpMail *cxpmail ;

static GtkWidget *atenaInfoWindow;
static GtkWidget *canBtn;
static GtkWidget *atenaEntry1;
static GtkWidget *atenaEntry2;
static GtkWidget *atenaEntry3;
static GtkWidget *atenaEntry4;
static GtkWidget *atenaEntry5;
static GtkWidget *atenaEntry6;
static GtkWidget *atenaEntry7;
static GtkWidget *atenaEntry8;
static GtkWidget *atenaEntry9;
static GtkWidget *atenaEntry10;
static GtkWidget *atenaEntry11;
static GtkWidget *atenaEntry12;
static GtkWidget *atenaEntry13;
static GtkWidget *atenaEntry14;

static void canBtnCallBack(GtkWidget *widget, gpointer data )
{           
    gtk_widget_destroy(atenaInfoWindow);
}

int create_atenaInfoWindow (ADDRINFO *info)
{
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hbox2;
  GtkWidget *vbox2;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *vbox3;
  GtkWidget *hbox1;
  int x,y,w,h ;

  w = gdk_screen_width();
  h = gdk_screen_height();
  x = w/2;
  y = h/2;


  atenaInfoWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (atenaInfoWindow), "atenaInfoWindow", atenaInfoWindow);
  gtk_window_set_title (GTK_WINDOW (atenaInfoWindow), "̾");
  gtk_widget_set_usize (atenaInfoWindow, 500, 500);
  gtk_widget_set_uposition(atenaInfoWindow, (x - 500*0.5), (y - 500*0.5) );
  gtk_widget_show (atenaInfoWindow);


  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (atenaInfoWindow), vbox1);

  label1 = gtk_label_new ("̾");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 5);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  vbox2 = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox2, FALSE, TRUE, 7);

  label2 = gtk_label_new ("̾");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox2), label2, FALSE, FALSE, 0);

  label3 = gtk_label_new ("ɤ");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox2), label3, FALSE, FALSE, 0);

  label4 = gtk_label_new ("ҡع̾");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (vbox2), label4, FALSE, FALSE, 0);

  label5 = gtk_label_new ("Ϣֹ桧");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (vbox2), label5, FALSE, FALSE, 0);

  label6 = gtk_label_new ("̡");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (vbox2), label6, FALSE, FALSE, 0);

  label7 = gtk_label_new ("ǯ");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (vbox2), label7, FALSE, FALSE, 0);

  label8 = gtk_label_new ("շ");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox2), label8, FALSE, FALSE, 0);

  label9 = gtk_label_new ("͹ֹ桧");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (vbox2), label9, FALSE, FALSE, 0);

  label10 = gtk_label_new ("ꡧ");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox2), label10, FALSE, FALSE, 0);

  label11 = gtk_label_new ("ֹ桧");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (vbox2), label11, FALSE, FALSE, 0);

  label12 = gtk_label_new ("ƣֹ桧");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (vbox2), label12, FALSE, FALSE, 0);

  label13 = gtk_label_new ("Żҥ᡼롧");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (vbox2), label13, FALSE, FALSE, 0);

  label14 = gtk_label_new ("ۡڡ");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (vbox2), label14, FALSE, FALSE, 0);

  label15 = gtk_label_new ("ȡ");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (vbox2), label15, FALSE, FALSE, 0);

  vbox3 = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox3, TRUE, TRUE, 10);

  atenaEntry1 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry1);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry1", atenaEntry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry1);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry1, FALSE, FALSE, 0);

  atenaEntry2 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry2);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry2", atenaEntry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry2);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry2, FALSE, FALSE, 0);

  atenaEntry3 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry3);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry3", atenaEntry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry3);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry3, FALSE, FALSE, 0);

  atenaEntry4 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry4);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry4", atenaEntry4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry4);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry4, FALSE, FALSE, 0);

  atenaEntry5 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry5);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry5", atenaEntry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry5);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry5, FALSE, FALSE, 0);

  atenaEntry6 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry6);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry6", atenaEntry6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry6);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry6, FALSE, FALSE, 0);

  atenaEntry7 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry7);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry7", atenaEntry7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry7);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry7, FALSE, FALSE, 0);

  atenaEntry8 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry8);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry8", atenaEntry8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry8);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry8, FALSE, FALSE, 0);

  atenaEntry9 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry9);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry9", atenaEntry9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry9);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry9, FALSE, FALSE, 0);

  atenaEntry10 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry10);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry10", atenaEntry10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry10);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry10, FALSE, FALSE, 0);

  atenaEntry11 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry11);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry11", atenaEntry11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry11);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry11, FALSE, FALSE, 0);

  atenaEntry12 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry12);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry12", atenaEntry12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry12);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry12, FALSE, FALSE, 0);

  atenaEntry13 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry13);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry13", atenaEntry13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry13);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry13, FALSE, FALSE, 0);

  atenaEntry14 = gtk_entry_new ();
  gtk_widget_ref (atenaEntry14);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "atenaEntry14", atenaEntry14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atenaEntry14);
  gtk_box_pack_start (GTK_BOX (vbox3), atenaEntry14, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 5);

  canBtn = gtk_button_new_with_label (" Ĥ ");
  gtk_widget_ref (canBtn);
  gtk_object_set_data_full (GTK_OBJECT (atenaInfoWindow), "canBtn", canBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (canBtn);
  gtk_box_pack_start (GTK_BOX (hbox1), canBtn, TRUE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (canBtn), "clicked",
       (GtkSignalFunc) canBtnCallBack, NULL );

  /* Խػ */
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry1), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry2), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry3), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry4), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry5), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry6), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry7), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry8), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry9), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry10), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry11), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry12), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry13), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (atenaEntry14), FALSE);


  /* ǡɽ */
  gtk_entry_set_text( GTK_ENTRY(atenaEntry1),  info->name );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry2),  info->kana );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry3),  info->job );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry4),  info->jtel );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry5),  info->sex );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry6),  info->birth );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry7),  info->bload );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry8),  info->ybin );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry9),  info->addr );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry10), info->tel );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry11), info->fax );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry12), info->email );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry13), info->website );
  gtk_entry_set_text( GTK_ENTRY(atenaEntry14), info->comment );

}

