/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpmail.h"

extern CxpMail *cxpmail ;

static char *listtitle[2] = {
	"ưΥܥå̾",
	" " };

static GtkWidget *moveMailWin;
static GtkWidget *moveBoxName;
static GtkWidget *MoveMailList;
static GtkWidget *setBtn;
static GtkWidget *canBtn;
static int selectrow ;
static int viewPoint ;
static int selectnumber ;

static int listselection(GtkWidget *clist, gint row, gint column,
                GdkEventButton *event, gpointer data )
{
    if ( row < 0 )
	return(0);

    selectrow = row ;

    return(0);
}

static int setFunction(GtkWidget *widget, GtkWidget *win )
{
    if ( viewPoint == selectrow )
    {
	create_messageWin(cxpmail->window,
	    "ƱܥåʤΤǽޤ");
	return(0);
    }

    cxpmail_movemail_withview( viewPoint, selectrow, selectnumber );

    gtk_widget_destroy(win);
}

static int cancelFunction(GtkWidget *widget, GtkWidget *win )
{
    gtk_widget_destroy(win);
}


int create_moveMailWin ()
{
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *label1;
  GtkWidget *hbox2;
  GtkWidget *label2;
  GtkWidget *hbox4;
  GtkWidget *hbox3;
  GtkWidget *swin;
  char *boxname[2];
  int x,y,w,h ;
  int i, count ;

  w = gdk_screen_width();
  h = gdk_screen_height();
  x = w * 0.5;
  y = h * 0.5;

  selectrow = cxpmail->minfo.viewPoint ;
  if ( selectrow < 0 )
  {
	return(0);
  }
  viewPoint = selectrow ;
  selectnumber = cxpmail->select_title - 1 ;
  if ( selectnumber < 0 )
  {
	return(0);
  }

  moveMailWin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (moveMailWin), "moveMailWin", moveMailWin);
  gtk_window_set_title (GTK_WINDOW (moveMailWin), "᡼ư");
  gtk_widget_set_usize(moveMailWin, 100, 100);
  gtk_window_set_default_size(GTK_WINDOW(moveMailWin),350,400);
  gtk_widget_set_uposition(moveMailWin, (x - 350*0.5), (y - 400*0.5) );
  gtk_widget_show (moveMailWin);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (moveMailWin), hbox1);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 8);

  label1 = gtk_label_new ("᡼ưܥå򤷤Ʋ");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox2), label1, FALSE, FALSE, 10);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, TRUE, 10);

  label2 = gtk_label_new ("ߤΥܥå");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox2), label2, FALSE, FALSE, 0);

  moveBoxName = gtk_label_new ( cxpmail->minfo.box[selectrow]->boxName );
  gtk_widget_ref (moveBoxName);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "moveBoxName", moveBoxName,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (moveBoxName);
  gtk_box_pack_start (GTK_BOX (hbox2), moveBoxName, FALSE, FALSE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox4, TRUE, TRUE, 0);

#if 0
  MoveMailList = gtk_list_new ();
  gtk_widget_ref (MoveMailList);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "MoveMailList", MoveMailList,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (MoveMailList);
  gtk_box_pack_start (GTK_BOX (hbox4), MoveMailList, TRUE, TRUE, 0);
#else
  swin = gtk_scrolled_window_new(NULL, NULL);

  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show(swin);

  MoveMailList = gtk_clist_new_with_titles( 1, listtitle );
  gtk_widget_set_usize(MoveMailList, 300, 250);
  gtk_clist_set_selection_mode( GTK_CLIST(MoveMailList),
		GTK_SELECTION_BROWSE );

  gtk_signal_connect(GTK_OBJECT(MoveMailList), "select_row",
	GTK_SIGNAL_FUNC(listselection), NULL);
  gtk_container_add(GTK_CONTAINER(swin), MoveMailList);
  gtk_widget_show(MoveMailList);

  gtk_box_pack_start (GTK_BOX (hbox4), swin, TRUE, TRUE, 0);
#endif

  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, TRUE, 10);

  setBtn = gtk_button_new_with_label (" ư ");
  gtk_widget_ref (setBtn);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "setBtn", setBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (setBtn);
  gtk_box_pack_start (GTK_BOX (hbox3), setBtn, FALSE, FALSE, 0);

  canBtn = gtk_button_new_with_label ("  ");
  gtk_widget_ref (canBtn);
  gtk_object_set_data_full (GTK_OBJECT (moveMailWin), "canBtn", canBtn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (canBtn);
  gtk_box_pack_start (GTK_BOX (hbox3), canBtn, FALSE, FALSE, 0);

  /* Хåؿ */
  gtk_signal_connect (GTK_OBJECT (setBtn), "clicked",
        (GtkSignalFunc) setFunction, moveMailWin );

  /* Хåؿ */
  gtk_signal_connect (GTK_OBJECT (canBtn), "clicked",
        (GtkSignalFunc) cancelFunction, moveMailWin );


  /* ɽ */
  gtk_clist_freeze( GTK_CLIST(MoveMailList) );
  gtk_clist_clear( GTK_CLIST(MoveMailList) );

  selectrow = -1 ;
  for(i=0;i<MAX_BOX_NUM;i++)
  {
	if ( cxpmail->minfo.box[i] != (BoxInfo *)NULL )
	{
	    if ( cxpmail->minfo.box[i]->boxName != NULL )
	    {
		boxname[0] = g_strdup(cxpmail->minfo.box[i]->boxName);
		gtk_clist_append( GTK_CLIST(MoveMailList), boxname );
		gtk_clist_set_row_style (GTK_CLIST (MoveMailList),
				i, cxpmail->styleNormal);
	    }
	}
  }


  /* Υܥå򤹤 */
  gtk_clist_select_row( GTK_CLIST(MoveMailList), selectrow, 0 );

  /* ɽ */
  gtk_clist_thaw( GTK_CLIST(MoveMailList) );

  return(0);
}

