/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                                hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpmail.h"

extern CxpMail *cxpmail ;

/*
 * Cxptar Version Header
 *
 * version  date        log
 *  1.0.0   2000/05/01  first released.
 *  1.0.1   2000/05/03  exec error bug fix.
 *  1.0.2   2000/05/16  help message bug fix.
 *                      mail delete/undelete mode add.
 *                      From: "" <xxx@yyy.co.jp> is "" delete.
 *                      To: konta<xxx.yyy.org> -> konta <xxx.yyy.org> chg.
 *                      Header MINE Encording Supported.
 *                      sousinzumi fw Supported.
 *  1.0.3   2000/06/12  encode area malloc 2 -> 3scale
 *                      title list no subeteno jyouhou wo alloc site itanode 
 *                           korewo tuneni hitotu no jyouhou dake memory alloc
 *                           suruyouni sita. mae ha title ga 500 ken attatoki,
 *                           memory wo 80MByte mo sennyuu siteita. kono kaisyu
 *                           niyori 20MByte ika ni osaerukotoga dekiru.
 *                      thread exit attribute change. (DETACHD)
 *                      In-Reply-To: Add.
 *                      new atena / atena info support.
 *                      nday mail delete add.
 *                      same mail not get add.
 *  1.0.4   2000/06/28  window manager destroy event support.
 *                      thread stop -> normal func.
 *                      nday mail delete bug fix.
 *                      same mail not get bug fix.
 *  1.0.5   2000/08/03  cxpmanager start add.
 *                      view size setting add.
 *  1.1.0   2000/10/01  cxpmail memory small used change.
 *                      title area date month -1 bug fix.
 *                      kakikake mail -> send mail error bug fix.
 *                      title encoding bug fix.
 *  1.1.1   2000/10/16  cxpmail password file security fix.
 *  1.1.2   2001/09/14  title null supported
 *
 */

static char CxpMailTitle[] =
"CxpMail Version 1.1.2 Sep./14/2001 (C)K.Hatakeda" ;

static char *MailVersion = "CxpMail Ver 1.1.2 2001/09/14" ;
static char *Version     = "С 1.1.2 2001/09/14" ;
static char *Website     = "http://www1.sphere.ne.jp/hatakeda" ;
static char *Email       = "Mail:hatakeda@mbm.sphere.ne.jp" ;
static char *EmailJ      = "Ϣ衧hatakeda@mbm.sphere.ne.jp" ;
static char *Copyright   = "Copyright 1998-2000 Konta" ;

char *getdataTitle()
{
        return(CxpMailTitle);
}
char *getdataVersion()
{
        return(MailVersion);
}
char *getdataJVersion()
{
        return(Version);
}
char *getdataEmail()
{
        return(Email);
}
char *getdataJEmail()
{
        return(EmailJ);
}
char *getdataUrl()
{
        return(Website);
}
char *getdataCopyright()
{
	return(Copyright);
}
