/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxplorer.h"

/* ѥͥ */
int getPanelConfig( kensu, panel )
int		*kensu ;
PANELINFO	*panel ;
{
	FILE	*fp ;
	char	configbuff[1024] ;
	char	workbuff[1024] ;
	char	filename[512] ;
	char	*ptr ;
	int	n ;

	sprintf( filename, "%s/.cxp/panel/panel.cfg", (char*)getenv("HOME") );
	if ( access( filename, F_OK ) )
	{
		/* ե뤬¸ߤʤä饷ƥΥǡ */
		strcpy( filename, (char *)getPath(CXPSYSTEM_PANEL) );
	}

	if ( (fp = fopen( filename, "r" )) == NULL )
	{
		fprintf(stdout,"Panel config file open error [%s]\n",
				filename );
		return(-1);
	}

	(*kensu) = 0 ;
	memset( configbuff, 0x00, sizeof(configbuff) );
	while( fgets( configbuff, sizeof(configbuff), fp) != 0)
	{
	    if (( configbuff[0] == '#'  ) ||  ( configbuff[0] == '\n' )
	    ||  ( configbuff[0] == '\t' ) ||  ( configbuff[0] == ' '  ))
		continue ;

	    /* XPMեФ */
	    memcpy( workbuff, configbuff, sizeof(configbuff) );
	    ptr = nstrchr ( workbuff, '"', 2 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( workbuff, '"', 1 );
	    panel[*kensu].xpm = g_strdup( (char *)getPath(ptr+1) );

	    /* ץꥱФ */
	    memcpy( workbuff, configbuff, sizeof(configbuff) );
	    ptr = nstrchr ( workbuff, '"', 4 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( workbuff, '"', 3 );
	    panel[*kensu].command = g_strdup( ptr+1 );

	    /* ҥȾФ */
	    memcpy( workbuff, configbuff, sizeof(configbuff) );
	    ptr = nstrchr ( workbuff, '"', 6 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( workbuff, '"', 5 );
	    panel[*kensu].hint = g_strdup( ptr+1 );

	    (*kensu) ++ ;
	}

	fclose( fp );

	return( *kensu );
}

/* ѥͥ˥塼Ѿ */
int getPanelMenuConfig( kensu, pmenu )
int		*kensu ;
PMENUINFO	*pmenu ;
{
	FILE	*fp ;
	char	configbuff[1024] ;
	char	workbuff[1024] ;
	char	filename[512] ;
	char	*ptr ;
	int	n ;

	sprintf( filename, "%s/.cxp/panel/cxpmenu.cfg", (char*)getenv("HOME") );
	if ( access( filename, F_OK ) )
	{
		/* ե뤬¸ߤʤä饷ƥΥǡ */
		strcpy( filename, (char *)getPath(CXPSYSTEM_PMENU) );
	}

	if ( (fp = fopen( filename, "r" )) == NULL )
	{
		fprintf(stdout,"Panel menu config file open error [%s]\n",
				filename );
		return(-1);
	}

	(*kensu) = 0 ;
	memset( configbuff, 0x00, sizeof(configbuff) );
	while( fgets( configbuff, sizeof(configbuff), fp) != 0)
	{
	    if (( configbuff[0] == '#'  ) ||  ( configbuff[0] == '\n' )
	    ||  ( configbuff[0] == '\t' ) ||  ( configbuff[0] == ' '  ))
		continue ;

	    /* ˥塼̾Ф */
	    memcpy( workbuff, configbuff, sizeof(configbuff) );
	    ptr = nstrchr ( workbuff, '"', 2 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( workbuff, '"', 1 );
	    pmenu[*kensu].menuname = g_strdup( ptr+1 );

	    /* ץꥱФ */
	    memcpy( workbuff, configbuff, sizeof(configbuff) );
	    ptr = nstrchr ( workbuff, '"', 4 );
	    *ptr = 0x00 ;
	    ptr = nstrchr ( workbuff, '"', 3 );
	    pmenu[*kensu].command = g_strdup( ptr+1 );

	    (*kensu) ++ ;
	}

	fclose( fp );

	return( *kensu );
}
