/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxprestore.h"

CxpRestore *cxprestore ;

extern void sigChildFunc();

main( int argc, char *argv[] )
{
    struct sigaction sigChildAct ;

    CxpBasePathInit();

    /* ޥ͡㵯ư */
    cxp_manager_start();

    cxprestore = (CxpRestore *)g_malloc(sizeof(CxpRestore));
    memset(cxprestore,0x00,sizeof(CxpRestore));

    /* ưɣĤμ */
    cxprestore->uid = getuid();
    cxprestore->gid = getgid();
    cxprestore->pid = getpid();

    /* ١ɤ߹ */
    getBaseConfig( &cxprestore->base ) ;

    /* ǥХɤ߹ */
    getDeviceConfig( &cxprestore->devinf ) ;


    /* ʥ */
    sigChildAct.sa_flags   = 0 ;
    sigChildAct.sa_handler = sigChildFunc ;
    sigfillset(&sigChildAct.sa_mask);
    sigaction( SIGCHLD, &sigChildAct, NULL);

    gtk_set_locale();
    gtk_init (&argc, &argv);

    cxprestore_start();

    gtk_main();
    exit(0) ;
}
