/*
 * Cxp -- Cxp Desktop Environment Software.
 * Copyright (C) 1998-2000 Konta <hatakeda@mbm.sphere.ne.jp>
 *
 * This program is free software;
 *
 *                                             hatakeda@mbm.sphere.ne.jp
 *      Cxp Home Page http://www1.sphere.ne.jp/hatakeda/cxplorer/index.html
 *
 */

#include "cxpcommon.h"
#include "cxpsocket.h"

/*-- СȤ³򳫻Ϥ --*/
int cxpsocket_cliconnect (void)
{
    struct sockaddr_un address ;
    int sock ;
    size_t addrLength ;

    if ( (sock = socket(PF_UNIX, SOCK_STREAM, 0 )) < 0 )
    {
#ifdef	DEBUG_SOCKET
	fprintf(stderr,"socket error\n");
#endif
	return(-1);
    }

    address.sun_family = AF_UNIX ;
    strcpy( address.sun_path, CXPSOCKET_NAME );

    addrLength = sizeof(address.sun_family) +
                 strlen(address.sun_path) ;

    if(connect(sock, (struct sockaddr *)&address, addrLength))
    {
#ifdef	DEBUG_SOCKET
	fprintf(stderr,"connect error\n");
#endif
	close(sock);
	return(-2);
    }

#ifdef	DEBUG_SOCKET
    fprintf(stderr,"cxpsocket_cliconnect: sock -> %d\n", sock );
#endif

    return( sock );

}

/*-- ФȤ³ --*/
int cxpsocket_cliclose ( int sock)
{
    close(sock);

    return(0);
}
